/* Ein Standard-Rattskin, fuer das Gebiet unterhalb der Kanalisation
 * Samtpfote@Tamedhon.
 */
#include <properties.h>
#include <combat.h>
#include <new_skills.h>
#include <moving.h>

inherit "std/inpc/select";
inherit "std/npc";

#ifdef LOG
#undef LOG
#endif
#define LOG(x, text) write_file("/log/statistik/npcs/"+x, text)
#define CAP(x)          capitalize(x)
#define TO              this_object()
#define TP              this_player()
#define ETO             environment()

void attack_goodie(object who)
{
    if(!who) return;

    say(CAP(name(WER))+" ertraegt diesen heiligen Fatzke von "+
	CAP(who->name(WEN))+" nicht mehr laenger.\n");
    Kill(who);	
}


void Attack(object en)
{
    int		i, is;
    object	*inv;

    if(en)
    {
    	if(ETO && (is=sizeof(inv=all_inventory(ETO))))
	{
	    for(i=0; i<is; i++)
	    {
		if(inv[i]->id("\nrattskin") && !inv[i]->InFight())
		{ 
		    // DBS(CAP(name(RAW))+": Greife "+en->name()+" an.");
		    inv[i]->Kill(en); 
		}
	    }	    
	}
    }
    
    if(random(10) < 3) { command("benutze_beste_sonderwaffe"); }
    ::Attack(en);
}

void init()
{
    object	ob, *inv;
    int		i, is;

    ::init();
    
    if(ob=present("leiche", ETO))
    {
	say(CAP(name(WER))+" macht sich genuesslich ueber eine Leiche her.\n");
	ob->remove(1);
	heal_self(random(50));
	command("nimm alles");
	command("wield_best_weapon");
	command("wear_best_armours");
    }
    
    is=sizeof(inv=all_inventory(ETO));
    if(is)
    for(i=0; i<is; i++)
    {
	if(living(ob=inv[i]) && (ob->QueryProp(P_ALIGN) > 200))
	{
	    call_out("attack_goodie", 0, ob);
	}
    }
}

int create()
{
    if(!is_clone(TO)) return 0;
    ::create();
    
    AddId("\nrattskin");
    AddId(({"rattenmensch", "rattskin"}));
    create_default_npc(15);
    SetProp(P_GENDER, MALE);
    SetProp(P_NAME, "Rattskin");
    SetProp(P_SHORT, "Ein Rattskin");
    SetProp(P_LONG, break_string(
	"Das ist ein durchschnittlicher Rattskin, ohne jede "+
	"Besonderheiten. Da war wohl jemand etwas faul, ihn besser "+
	"zu beschreiben..."));	
    SetProp(P_RACE, "Rattenmensch");
    SetProp(P_HANDS, ({" mit rattenaehnlichen Krallen", 90, DT_RIP}));
    SetProp(P_BODY, 15);
    SetProp(P_SIZE, 115+random(35));
    SetProp(P_AVERAGE_SIZE, 125);
    SetProp(P_WEIGHT, 40000+random(20000));
    SetProp(P_AVERAGE_WEIGHT, 50000);
    SetProp(P_ALIGN, -random(400)-100);
    SetProp(P_MSGIN, "laeuft sabbernd herein");
    SetProp(P_MSGOUT, "laeuft sabbernd");
    SetProp(P_MMSGIN, "manifestiert sich");
    SetProp(P_MMSGOUT, "verschwindet");
    SetProp(P_VULNERABILITY, ({ DT_HOLY, DT_LIGHT }));
    SetProp(P_RESISTANCE, 
	({DT_WATER, DT_POISON, DT_UNHOLY, DT_TERROR, DT_MAGIC}));
    SetProp(P_KILL_NAME, "Ein Rattskin");
    SetProp(P_KILL_MSG, "Mjaaaaam, eine frische Mahlzeit!");
    SetProp(P_DIE_MSG, " blickt unglaeubig, bevor tot zu Boden geht.\n");
    SetProp(P_DEFAULT_INFO, "blickt dich hasserfuellt an.\n");
    SetProp(P_REJECT, 
	({REJECT_KEEP, 
	  "Der Rattskin grinst Dich fies an und gibt @WEN nicht mehr her!\n"}));
    
    SetProp(P_SPELLRATE, 35);
    AddSpell(2, 180,
	"Der Rattenmensch versetzt Dir einen heimtueckischen Faustschlag.\n",
	"Der Rattenmensch versetzt @WEN einen heimtueckischen Faustschlag.\n",
	({ DT_RIP, DT_BLUDGEON }),
	([ SP_SHOW_DAMAGE: 1, SP_PHYSICAL_ATTACK: 1]));
    AddSpell(1, 270,
	"Der Rattenmensch tritt Dir heftig in den Bauch.\n",
	"Der Rattenmensch tritt @WEN heftig in den Bauch.\n",
	({ DT_BLUDGEON }),
	([ SP_SHOW_DAMAGE: 1, SP_PHYSICAL_ATTACK: 1]));

    SetProp(P_AGGRESSIVE, 0);        
    
    AddItem("/d/gidhrog/samtpfote/kanalisation/armour/rattskinband", CLONE_WEAR);
    add_select_commands();
}
