// MorgenGrauen MUDlib
//
// DEF_WORKROOM.C -- standard workroom for new wizards
//
// $Date: 1995/02/06 22:14:18 $                      
// $Revision: 2.5 $       
/* $Log: def_workroom.c,v $
 * Revision 2.5  1995/02/06  22:14:18  Kirk
 * strong_types and some details added
 *
 * Revision 2.4  1995/02/06  19:44:14  Jof
 * RCS-Logs aufgeraeumt (leere Logs raus usw)
 *
 * Revision 2.3  1994/11/02  21:28:49  Kirk
 * added leading / to gilden/abenteurer
 *
 * Revision 2.2  1994/10/26  01:25:27  Rochus
 * Gilde verlegt.
 *
 * Revision 2.1  1994/03/21  16:48:13  Jof
 * Reindented files using emacs - once again
 *
 */                            

#pragma strong_types

inherit "std/room";

#include <properties.h>

void create()
{
  string WIZNAME;

  ::create();
  WIZNAME = capitalize(getuid(this_object()));

  SetProp( P_LIGHT, 1 );
  SetProp( P_INT_SHORT, "Der Arbeitsraum von "+WIZNAME );
  SetProp( P_INT_LONG,
   "Dieses ist der Arbeitsraum von "+WIZNAME+". Es liegen vollgeschriebene\n"
  +"Zettel auf dem Boden, die Waende sind mit Kreidezeichen zugekritzelt.\n"
  +"Man merkt, dass dieser Raum dafuer da ist, dass "+WIZNAME+" fuer sich\n"
  +"ungestoert arbeiten kann. Ein magisches Portal fuehrt in die Welt\n"
  +"der Sterblichen.\n"
	  );
  SetProp(P_INDOORS,1);
  AddDetail( ({ "portal", "portale" }), 
	    "Das Portal fuehrt in die Abenteurer-gilde.\n" );
  AddDetail( ({ "raum", "arbeitsraum" }),
	     "Du befindest Dich mittendrin.\n" );
  AddDetail( "zettel",
	     "Die Zettel sind mit unleserlichen Zeichen vollgeschrieben.\n" );
  AddDetail( ({ "boden", "fussboden" }),
	     "Der Fussboden ist bedeckt mit vollgeschriebenen Zetteln.\n" );
  AddDetail( ({ "wand", "waende" }),
	     "An den Waenden befinden sich Kreidezeichen.\n" );
  AddDetail( ({ "kreide", "kreidezeichen", "zeichen" }),
	    "Die Zeichen ergeben nur fuer " + WIZNAME + " einen Sinn.\n" );
  AddDetail( "portal",
	     "Das Portal fuehrt in die Welt der Sterblichen.\n" );
  AddExit("gilde","in die Gilde#/gilden/abenteurer");
}
