// Tamedhon MUDlib
//
// PLAYER/BASE.C -- the basic player object
//
// $Date: 2002/02/14 08:54:00 $                      
/* $Revision: 1.9 $       
 * $Log: base.c,v $
 * Revision 1.9  2002/02/14 08:54:00  Querolin
 * diverse bugs entfernt. sowie advance fuer /std/gilde.c auskommentiert.
 *
 * Revision 1.8  2001/06/24 16:56:00  Querolin
 * stty noch umgebaut, damit P_COLOR* zurueckgesetzt wird!
 *
 * Revision 1.7  2001/06/04 12:56:00  Querolin
 * Einbau von 'icq' und 'homepage'.
 *
 * Revision 1.6  2001/06/02 16:45:00  Querolin
 * Einbau von 'farbe'.
 *
 * Revision 1.5  2001/01/28 19:09:36  Samtpfote
 * Autokorrekur von P_ALIGN, wenns zu gross/klein ist.
 *
 * Revision 1.4  2001/01/18 10:19:30  Samtpfote
 * Grammatikfehler bei der Gewichtsanzeige ausgebuegelt
 *
 * Revision 1.3  2001/01/17 19:57:58  Samtpfote
 * EMail-Adresse kann nun geloescht werden
 * persoenliche Angabe des Ortes nun moeglich
 *
 * Revision 1.2  2001/01/13 17:24:05  Samtpfote
 * Invis kann man nur mehr ab Magierlevel 35 werden
 *
 * Revision 1.1  2001/01/13 12:14:22  Samtpfote
 * Initial revision
 *
 *
 * Revision 1.2   2001/01/05 18:20:00  Querolin
 * Bei 'Vorsicht' die Eingabe von Prozenten ermoeglicht
 *
 * Revision 1.1   2001/01/04 22:00:01  Querolin
 * Gewichtsanzeige bei 'info' eingebaut
 *
 * Revision 1.0   2001/01/04 22:00:00  Querolin
 * Initialiesierung der Versionsnummer
 *
 * Revision 3.21  1998/02/12 15:40:17  Woody
 * P_DEFAULT_GUILD SAVE setzen, bei score beruecksichtigen
 * Spielerobjekt speichern nach erfolgter Initialisierung
 *
 * Revision 3.20  1998/02/05 02:02:40  Woody
 * Typo bei 'bug', wodurch Bugs nicht in .bug landeten, beseitigt
 *
 * Revision 3.19  1998/01/23 21:19:11  Woody
 * Bugfix in wache()
 *
 * Revision 3.18  1998/01/21 16:05:02  Feyaria
 * Aufsplitten des repfiles nach typ und region, befehl detail
 *
 * Revision 3.17  1998/01/15 08:03:07  Crea
 * removed start_player(): Set(P_WANTS_TO_LEARN, 1); => now prop is saved and restored right.
 *
 * Revision 3.16  1997/11/25 15:53:03  Feyaria
 * pluendern
 *
 * Revision 3.15  1997/11/10 12:15:25  Feyaria
 * titel, presay msgin msgout laengenmaessig beschraenkt
 *
 * Revision 3.14  1997/11/05 19:33:16  Feyaria
 * Silberland in MUDNAME
 *
 * Revision 3.13  1997/11/05 16:20:00  Woody
 * remote fuer Seher mit allen QP, zeilen rel|abs, Rasten/Aufstehen/wachen
 *
 * Revision 3.12  1997/09/28 02:05:39  Woody
 * Zurueck von den Netztoten nicht mehr M_SILENT
 *
 * Revision 3.11  1997/09/20 11:17:55  Woody
 * behalte waffen|ruestungen|alles|nichts eingebaut
 *
 * Revision 3.10  1997/09/17 14:36:37  Woody
 * passwd Variable private, seltsamem getmanpage() Verhalten vorbeugen,
 * Erwartete auch bei Reconnect anzeigen, P_TESTPLAYER setzt autom. uid
 *
 * Revision 3.9  1997/08/28 12:52:08  Woody
 * Bei 'wer' nun auch explizit 'mud mudname' moeglich
 *
 * Revision 3.8  1997/08/21 14:55:55  Woody
 * Bugfix (wer -a ging nimmer...)
 *
 * Revision 3.7  1997/08/21 14:11:05  Woody
 * wer weiter verbessert, auch weitere Parameter per UDP verschicken
 * (kwer -a silberland elf und aus wien etc.)
 *
 * Revision 3.6  1997/08/20 22:56:02  Woody
 * wer -k etc. auch remote
 *
 * Revision 3.5  1997/08/05 14:12:34  Feyaria
 * titel mit \b NUR fuer beistrich!!
 *
 * Revision 3.4  1997/06/25 12:00:12  Woody
 * quit() im Kampf verzoegert, sonst je nach letztem Spell,
 * RCS logs aufgeraeumt, checkConsistency(), smart_log Bugfix,
 * SmartLog() in Objekten aufrufen, wieder 2 \n beim log,
 * call PlayerQuit() auch im inventory von Spieler und Raum,
 * P_NOQUIT verhindert quitten, P_NO_GLOBAL_ATTACK+P_FRIEND,
 * gremote in rgemote umbenannt, P_MV nach Reboot auf Max,
 * Mini-Editor fuer Extralook, Befehl erweitert, Autoload
 * von VC-Objekten moeglich, vorsicht bugfixed, stty reset,
 * ANSI/VT100 Farbtest bei stty, alle M_GO moves M_NOCHECK
 *
 * Revision 3.3  1997/06/23 11:00:40  Woody
 * Big Brother installiert
 *
 * Revision 3.2  1997/05/15 00:12:36  Woody
 * Auf Wuschels Quengeln hin kriegen Magier /etc/NEWS nicht mehr
 * zu lesen (beim Login), dafuer aber /etc/WIZNEWS :)
 *
 * Revision 3.1  1997/03/16 03:48:28  Woody
 * Verwendet jetzt finger aus /p/service/obj/
 *
 * Revision 3.0  1997/03/13 01:31:11  Woody
 * prepared for revision control
 *
 * Revision 2.180  97/02/10, Woody
 * punkte/score und info getrennt, altes Format endgueltig verworfen
 *
 * Revision 2.179  97/02/03, Woody
 * P_ALIGN_STRING, Vergiftung nach Reboot weg
 *
 * Revision 2.178  97/01/25, Woody
 * query_ip_name(ME) statt query_ip_name(), where() rausgeworfen
 *
 * Revision 2.177  97/01/22, Woody
 * P_CALLED_FROM_IP(_NAME) richtig setzen (zudem auch bei Reconnect),
 * ebenso P_LAST_LOGIN (ebenfalls auch bei Reconnect) und P_LAST_LOGOUT
 * (bei disconnect() und quit() statt bei save_me())
 *
 * Revision 2.176  97/01/18, Woody
 * BecomesNetAlive() auch aufrufen wenn 'nur' disconnected gewesen...
 *
 * Revision 2.175  97/01/06, Woody
 * Postkastensymbol beim Einloggen, wenn Briefe im Postamt
 * (g)remote nicht erst ab Seher
 *
 * Revision 2.174  96/10/12, Woody
 * Befehl gremote wieder aktiviert (ist dasselbe wie "r;")
 *
 * Revision 2.173  96/10/02, Woody
 * Generalrevision: :)
 * creation_date wieder raus (wird nun von login non-SAVE aber SECURE gesetzt)
 * AddId("Interactive"), selbstloeschungstext geaendert, Befehl 'spielpause',
 * Austreten aus Gilde bei selbstloeschung, Anderer Text bei Selbstloeschung
 * bei 5 oder mehr Toden, Vergiftung wird in 'score[2]' angezeigt,
 * hardcoded Einlogg-Text raus (sollte eh in /etc/NEWS stehn),
 * Saettigung (Food und Drink) und Alkohol werden nach Reboot auf 0 gesetzt,
 * Levelobergrenze von 40 auf 75 angehoben, unparsed_args fuer Fluchtrichtung
 *
 * Revision 2.172  96/10/01, Woody
 * *filterattr* an neues Attributsystem angepasst (A_MIN/A_MAX),
 * Stufen- und Attributpunkte in score-Anzeige rein
 *
 * Revision 2.171  96/09/30, Woody
 * P_GUILD_RATING rein.
 *
 * Revision 2.170  96/09/25, Woody
 * std/player/exploration reingehaengt.
 *
 * Revision 2.169  96/09/24, Woody
 * int creation_date, _query_creation_date, P_CREATION_DATE,
 * parentmaster nach /secure verschoben, score2 Anzeige.
 *
 * Revision 2.168  96/07/02, Woody
 * typo/bug/idea bezieht sich nun *immer* auf Raum (ausser bei "idee x:yz"),
 * ein evtl. P_REFERENCE_OBJECT wird in {} nachgestellt.
 *
 * Revision 2.167  96/06/08, Woody
 * Titel setzen u.ae. beim login fuer Gaeste debugged
 *
 * Revision 2.166  96/05/27, Woody
 * PARENTMASTER->RemoveWiz() bei selbstloeschung aufrufen
 *
 * Revision 2.165  96/05/26, Woody
 * "review" an "#" Makro fuer msgout angepasst
 *
 * Revision 2.164  96/05/25, Woody
 * Befehl "anzeige", inherited nun wieder /std/player/sense
 *
 * Revision 2.163g 96/04/29, Creative
 * BecomesNetAlive() -> auch fuer environment verwenden.
 *
 * Revision 2.163f 96/04/17, Woody
 * BecomesNetAlive()
 *
 * Revision 2.163e 96/04/17, Woody
 * fehler/typo/idee beruecksichtigen auch P_REFERENCE_OBJECT
 *
 * Revision 2.163d 96/04/14, Woody
 * emote gefixt (war erst ab Seher mgl.), gemote wiedereingefuehrt
 *
 * Revision 2.163c 96/01/25, Woody
 * al_to_title() nich mehr static
 *
 * Revision 2.163b 96/01/23, Woody
 * AnderLand -> SilberLand
 *
 * Revision 2.163a 96/01/16, Woody
 * msg wg. port 4711 raus
 *
 * Revision 2.163	02-02-1996	Mupfel
 * P_TEMPERATURE_RANGE wird ins savefile 'protected' uebernommen
 * dafuer '/sys/environment.h' included
 *
 */                            

#pragma strong_types

#include "/std/sys_debug.h"
#include <daemon.h>
#include <wizlevels.h>

inherit "/std/player/restrictions";
inherit "/std/living/attributes";
inherit "/std/living/combat";
inherit "/std/living/put_and_get";
inherit "/std/thing/properties";
inherit "/std/thing/util";
inherit "/std/thing/language";

inherit "/std/player/description";
inherit "/std/player/moving";
inherit "/std/player/life";
inherit "/std/player/comm";
inherit "/std/player/viewcmd";
inherit "/std/player/moneyhandler";
inherit "/std/player/command";
inherit "/std/player/sense";
inherit "/std/living/skills";
inherit "/std/player/quests";
inherit "/std/player/potion";
inherit "/std/player/exploration";
inherit "/std/player/soul";
inherit "/std/more";
inherit "/std/user_filter";

#ifdef NEDIT_FOR_EXTRALOOK
inherit "/mail/nedit";
#endif

#include <properties.h>
#include <udp.h>
#include <config.h>
#include <ansi.h>
#include <wizlevels.h>
#include <living.h>
#include <attributes.h>
#include <exploration.h>
#include <language.h>
#include <moving.h>
#include <defines.h>
#include <terminal.h>
#include <new_skills.h>
#include <environment.h>
#include <userinfo.h>
#include <pager.h>
#include "/secure/questmaster.h"
#include "/secure/parentmaster.h"

#define TW(x) if(find_player("woody")) tell_object(find_player("woody"),x)

#undef NAME /* DEFINED BY UDP.H; BAD NAME CLASH :( */
#define NAME(who) capitalize(getuid(who))

mapping autoload;           /* autoload-mapping */

static string saved_where;
private static string passw;        /* temporarily for password change */
private static string passwold;     /* temporarily for password change */

static string default_home; /* Where to move us if we dont have a home set */

static int ndead_lasttime;
static object ndead_location;
static string ndead_l_filename;
static int ndead_currently;
static int ndead_next_check;
static object *hb_obs;

static string pray_room;

static int _set_level(int i);
static int _set_invis(int a);
static string _set_tty(string str);
static mixed env_ndead_info;
static string my_ip;

// static string al_to_title(int a);
string al_to_title(int a);

static void ndead_revive();

static mixed PlayerMore();

int quit();
void save_me(mixed value_items);
varargs int remove(mixed arg);

void create()
{
  if(QueryProp(P_LEVEL)) return; // darf nur EINMAL gemacht werden

  call_out("checkConsistency", 0);

  ndead_next_check=NETDEAD_CHECK_TIME;
  ndead_lasttime=0;
  ndead_location=0;
  ndead_l_filename=0;
  ndead_currently=0;
  ndead_next_check=0;

  sense::create();
  command::create(); 
  properties::create();
  description::create();
  attributes::create();
  combat::create();
  life::create();
  comm::create();
  viewcmd::create();
  quests::create();
  restrictions::create();
  moving::create();
  exploration::create();

  SetProp(P_LEVEL, -1);
  Set(P_LEVEL, SAVE|SECURED, F_MODE_AS);
  Set(P_GHOST, SAVE, F_MODE_AS);
  SetProp(P_SCREENSIZE, 20);
  Set(P_SCREENSIZE, SAVE,F_MODE_AS);
  Set(P_MORE_FLAGS, SAVE, F_MODE_AS);
  SetProp(P_WEIGHT_PERCENT,100);
  SetProp(P_LONG, 0);
  SetProp(P_TITLE, "der hoffnungsvolle Anfaenger");
  SetProp(P_ALIGN, 0);
  SetProp(P_ALIGN_STRING, 0);
  SetProp(P_GENDER, NEUTER);
  Set(P_GENDER, SAVE, F_MODE_AS);
  SetProp(P_TTY, "vt100");
  Set(P_TTY, SAVE, F_MODE_AS);
  SetProp(P_WEIGHT, 75000);
  SetProp(P_MAX_HP,50);
  SetProp(P_MAX_SP,50);
  SetProp(P_MAX_FOOD,100);
  SetProp(P_MAX_DRINK,100);
  SetProp(P_MAX_ALCOHOL,100);
  SetProp(P_MAX_POISON,10);
  SetProp(P_DRINK, SetProp(P_MAX_DRINK,100));
  SetProp(P_FOOD, SetProp(P_MAX_FOOD,100));
  SetProp(P_ALCOHOL, 0);
  SetProp(P_ARMOURS,({}));
  SetProp(P_HANDS, ({" mit blossen Haenden", 30}));
  Set(P_HANDS, SAVE, F_MODE_AS);
  SetProp(P_MAX_HANDS, 2);
  SetProp(P_USED_HANDS, 0);
  
  Set(P_LOST_XP, SAVE|SECURED, F_MODE_AS);
  Set(P_LOOTING, SAVE, F_MODE_AS);
  SetProp(P_LOST_XP,0);
  SetProp(P_LOOTING,0);
  Set(P_MARRIED, SAVE, F_MODE_AS);
  Set(P_EXTRA_LOOK, SAVE, F_MODE_AS);
  Set(P_SHOW_EXITS, SAVE, F_MODE_AS);
  Set(P_SHOW_EXITS, 1);
  Set(P_WANTS_TO_LEARN, SAVE, F_MODE_AS);
  Set(P_CAN_FLAGS, SAVE, F_MODE_AS);
  Set(P_TESTPLAYER, SAVE, F_MODE_AS);
  Set(P_SECOND, SAVE, F_MODE_AS);
  Set(P_INVIS, SAVE, F_MODE_AS);
  Set(P_READ_NEWS, SAVE, F_MODE_AS);
  Set(P_START_HOME, SAVE, F_MODE_AS);
  Set(P_MAILADDR, SAVE, F_MODE_AS);
  Set(P_LOGON_PLACE, SAVE, F_MODE_AS);
 
  Set(P_CARRIED_VALUE, SAVE, F_MODE_AS);

  Set(P_PROMPT, "> ");
  Set(P_PROMPT, SAVE, F_MODE_AS);
  Set(P_CALLED_FROM_IP, SAVE, F_MODE_AS);
  Set(P_CALLED_FROM_IP_NAME, SAVE, F_MODE_AS);
  Set(P_INFORMME,SAVE|PROTECTED,F_MODE_AS);
  Set(P_WAITFOR,SAVE|PROTECTED,F_MODE_AS);

  autoload = ([]);
  SetProp(P_ARTICLE,0);
  Set(P_GUILD,SAVE,F_MODE_AS);
  Set(P_DEFAULT_GUILD,SAVE,F_MODE_AS);
  Set(P_GUILD_TITLE,SAVE,F_MODE_AS);
  Set(P_GUILD_LEVEL,SAVE,F_MODE_AS);
  Set(P_GUILD_RATING,SAVE,F_MODE_AS);
  Set(P_NEWSKILLS,SAVE,F_MODE_AS);
  Set(P_NEEDED_QP,QM->QueryNeededQP());
  Set(P_DEADS,0);
  Set(P_DEADS,-1,F_SET_METHOD);
  Set(P_DEADS,SAVE|PROTECTED|SECURED,F_MODE_AS);
  Set(P_LAST_AWAKE_TIME, SAVE|PROTECTED, F_MODE_AS);
  Set(P_LAST_LOGIN,-1);
  Set(P_LAST_LOGIN,-1,F_SET_METHOD);
  Set(P_LAST_LOGIN,SAVE|PROTECTED|SECURED,F_MODE_AS);
  Set(P_LAST_LOGOUT,-1);
  Set(P_LAST_LOGOUT,-1,F_SET_METHOD);
  Set(P_LAST_LOGOUT,SAVE|PROTECTED|SECURED,F_MODE_AS);
  Set(P_CLOCKMSG,SAVE,F_MODE_AS);
  Set(P_COLUMN_MODE,SAVE,F_MODE_AS);
  Set(P_SHORTINV,SAVE,F_MODE_AS);

  Set(P_TEMPERATURE_RANGE, PROTECTED, F_MODE_AS);
  SetProp(P_TEMPERATURE_RANGE, ([T_RANGE_MIN:5,T_RANGE_MAX:25]));

  Set(P_CMSG, 0, F_MODE); // to clean out the old clone messages
  Set(P_DMSG, 0, F_MODE);
  Set(P_CLONE_MSG, SAVE, F_MODE);
  SetProp(P_CLONE_MSG, "zaubert etwas hervor");
  Set(P_DESTRUCT_MSG, SAVE, F_MODE);
  SetProp(P_DESTRUCT_MSG, "verschwindet einfach");

  SetProp(P_WEIGHT, 70000+random(10000));
  SetProp(P_SIZE, 160+random(35));
  SetProp(P_AVERAGE_WEIGHT, 75000);
  SetProp(P_AVERAGE_SIZE, 173);
  
  Set(P_WEIGHT, SAVE, F_MODE_AS);
  Set(P_SIZE, SAVE, F_MODE_AS);
  Set(P_AVERAGE_WEIGHT, SAVE, F_MODE_AS);
  Set(P_AVERAGE_SIZE, SAVE, F_MODE_AS);

  AddId("Interactive");
}

void checkConsistency()
{
  int phands;
  
  phands=Query(P_HANDS)[1];
  if(((phands < 20) || (phands > 40)) && !IS_LEARNER(this_object())) {
    log_file("inconsistent", sprintf(
      "[%s] %O: HANDS: %d\n",dtime(time()),this_object(),Query(P_HANDS)[1]));
    Query(P_HANDS)[1] = 30;
  }
}

varargs int remove(mixed arg)
{
  return (int)moving::remove(arg);
}

varargs static void stop_heart_beats(mixed obs)
{
  int i;

  if (!obs)
  {
    hb_obs=({});
    obs=deep_inventory(ME);
  }
  for (i=sizeof(obs)-1;i>=0;i--)
    if (pointerp(obs[i]))
      stop_heart_beats(obs[i]);
    else
      if (set_object_heart_beat(obs[i],0))
    hb_obs+=({obs[i]});
}

static void restart_heart_beats()
{
  int i;

  if (pointerp(hb_obs))
  {
    for (i=sizeof(hb_obs)-1;i>=0;i--)
      set_object_heart_beat(hb_obs[i],1);
    hb_obs=0;
  }
}

varargs void Reconnect(int silent, string ip)
{
  int num;
  object *inv;

  my_ip=ip;
  enable_commands();
  set_living_name(getuid());
  _remove_netdead();
  set_heart_beat(1);
  restart_heart_beats();
  log_file("REENTER", 
       QueryProp(P_NAME) + ", " + extract(ctime(time()), 4, 15)+ ", "+
           query_ip_name(ME)+".\n");
  if (!silent&&environment()&&file_name(environment())!=NETDEAD_ROOM)
    say(QueryProp(P_NAME)+" weilt wieder unter den Lebenden.\n");
  if (!silent)
    "/secure/merlin"->notify_player_enter(getuid(ME));
  command::reconnect();
  ME->_set_currentdir(ME->_query_currentdir());
  if (num="secure/mailer"->FingerMail(geteuid()))
    write("\n  __ /\n"
            " |__|   Du hast "+num+" neue"+(num==1 ? "n Brief" : " Briefe")+
            " im Postamt liegen.\n\n");
  catch(VOICEMASTER->RegisterUser(ME));
  funcall(#'Set, P_CALLED_FROM_IP, query_ip_number()); //');
  funcall(#'Set, P_CALLED_FROM_IP_NAME, query_ip_name(ME)); //');
  if(query_once_interactive(ME))
    Set(P_LAST_LOGIN,time());
  if (ndead_currently) {
    string *list;
    object ob;
    int i,mag;

    list=QueryProp(P_WAITFOR);
    mag=IS_LEARNER(ME);
    for (i=sizeof(list)-1;i>=0;i--)
      if (!(ob=find_player(lower_case(list[i]))) || 
          (!mag && IS_LEARNER(ob) && ob->QueryProp(P_INVIS)))
	list=list[0..i-1]+list[i+1..];
    if (sizeof(list))
      write(break_string("Anwesende Erwartete: "+CountUp(list)+".", 78));

    ndead_revive();
  }
  else
  {
    if (environment())
      catch(environment()->BecomesNetAlive(ME));
    catch(map_objects(deep_inventory(ME), "BecomesNetAlive", ME));
    // (fuer Inventory ehemals NetDeadEnvironmentReconnected()...)
  }
}

void NetDead()
{
  object *inv;
  int nr;

  say("Ploetzlich weicht alles Leben aus "+QueryProp(P_NAME)+".\n");
  _set_netdead();
  remove_call_out("quit");
  remove_living_name();
  catch("secure/merlin"->notify_player_leave(geteuid(ME)));
  catch(VOICEMASTER->RemoveUser(ME));
  Set(P_LAST_LOGOUT,time());
  if (environment()) {
    catch(environment()->BecomesNetDead(ME));
    catch(map_objects(deep_inventory(ME)+all_inventory(environment()),
                      "BecomesNetDead", ME));
  }
  if (ME)
    ndead_location = environment();
}

static void ndead_move_me();

void heart_beat() {
  if (!ME)
    return;
  if (ndead_currently)
  {
    if (interactive(ME)) ndead_revive();
    else return;
  }
  else
    if (!(ndead_next_check--))
    {
      ndead_next_check=NETDEAD_CHECK_TIME;
      if (!interactive(ME))
        if (ndead_lasttime)
        {
          save_me(1);
          if (IS_LEARNER(ME))
          {
            quit();
            if (ME)
              remove();
            if (ME)
              destruct(ME);
            return;
          }
          ndead_move_me();
        }
        else
          ndead_lasttime=1;
    }
  if (ME && ndead_lasttime && interactive(ME))
    ndead_lasttime=0;
  life::heart_beat();
  combat::heart_beat();
}

/*
 * Identify ourself.
 * special temp handling for ghosts and i
 */
varargs int id(string str, int lvl) 
{
  if (::id(str))
    return 1;
  if (Query(P_INVIS) && lvl < QueryProp(P_LEVEL))
    return 0;
  if (QueryProp(P_GHOST)&& str == "geist von "+ lower_case(QueryProp(P_NAME)))
    return 1;
  if (QueryProp(P_FROG) && str == "frosch") return 1;
}

static int set_ort(string str)
{
    if(!stringp(QueryProp(P_LOGON_PLACE)))
    {
	call_other("/p/daemon/townd", "???");
	SetProp(P_LOGON_PLACE, 
	    "/p/daemon/townd"->get_information(this_player())[0]);
    }

    if(!(str=_unparsed_args()))
    {
	printf("Du kommst von '%s', wo immer das sein mag.\n",
	    QueryProp(P_LOGON_PLACE));
	return 1;
    }
    
    if(str == "loeschen")
    {
	write("Ok, persoenliche Ortsangabe entfernt.\n");
	call_other("/p/daemon/townd", "???");
	SetProp(P_LOGON_PLACE, 
	    "/p/daemon/townd"->get_information(this_player())[0]);
	return 1;
    }

    if(QueryProp(P_LEVEL) < 11)
    {
    	notify_fail("Sorry, dafuer musst du schon Stufe 11 haben.\n");
    	return 0;
    }
        
    SetProp(P_LOGON_PLACE, str);
    printf("Ok, Du bist nun in '%s' daheim.\n", str);
    return 1;
}

static int set_email(string str)
{
  if(QueryProp(P_MAILADDR) == "none") 
  { SetProp(P_MAILADDR, 0); }

  if (!(str=_unparsed_args())) 
  {
    if(!stringp(QueryProp(P_MAILADDR)))
    {
	write("Du hast Dir keine E-Mail Adresse gesetzt!\n");
	return 1;
    }
    write("Deine offizielle E-Mail Adresse lautet: "+
          QueryProp(P_MAILADDR)+"\n");
    return 1;
  }
  
  if(str == "loeschen")
  {
    write("Ok, Du hast Deine offizielle E-Mail Adresse geloescht.\n");
    SetProp(P_MAILADDR, 0);
  }
  else
  {
    write("Deine offizielle E-Mail Adresse wurde geaendert.\n");
    SetProp(P_MAILADDR, str);
  }
  return 1;
}

static int self_delete()
{
  write(
    "-----------------------------------------------\n"+
    "W I L L S T   D U   D A S   W I R K L I C H   ?\n"+
    "-----------------------------------------------\n"+
    "Wenn Du Dich selbstloeschst, ist Dein Charakter\n"+
    "UNWIDERRUFLICH verloren.  Es gibt  KEINE  Moeg-\n"+
    "keit, ihn wiederherzustellen, Du muesstest wie-\n"+
    "der ganz von vorne anfangen!! Falls Du es immer\n"+
    "noch willst, gib jetzt Dein Password ein.\n"+
    "Alternativ verwende den Befehl 'spielpause', um\n"+
    "nur voruebergehend hier fernzubleiben.\n"+
    "-----------------------------------------------\n");
  write("Bitte das Password angeben: ");
  input_to("self_delete2",1);
  return 1;
}

int self_delete2(string str)
{
  int ret;
  ret=(int)"secure/master"->delete_player(str, getuid(PL));
  if (!ret)
  {
    write("Das hat nicht hingehauen (Gott sei Dank ....)\n");
    return 1;
  }
  if (PL->QueryProp(P_GUILD))
    catch(call_other(GUILD_DIR+PL->QueryProp(P_GUILD), "austreten"));

  PARENTMASTER->RemoveWiz(getuid(ME));

  if (QueryProp(P_DEADS) < 5) {
    write("Adios! Man sieht sich.\n");
    say(name(WER,1)+" hat sich gerade selbst zerstoert.\n");
  }
  else {
    write( "\nTod kommt auf seinem weissen Pferd angeritten.\n"
+"Er steigt ab, baut sich drohend vor Dir auf und mustert Dich schadenfroh.\n"
+"\nTod sagt: ENDLICH! NUN KANN DIR AUCH LARS NICHT MEHR HELFEN!\n\n"
+"Tod holt weit mit seiner Sense aus. Mit grossem Schwung laesst er sie auf\n"
+"Dich zusausen und dann...\n");
    say(name(WER,1)+" schied gerade endgueltig von uns.\n");
  }
  remove(1);
  return 1;
}

static int spielpause(string str)
{
  int days;
  string foo;

  if (!str || sscanf(str, "%d tag%s", days, foo) != 2)
    return notify_fail("spielpause <x> tage\n"), 0;

  if (days < 0)
    days = -1;

  if (days > 0)
    printf("Du wirst Dich erst wieder am %s einloggen koennen!\n",
           dtime((time()/86400)*86400+days*86400)[0..16]);
  else if (days < 0)
    write( "Du wirst Dich auf unbestimmte Zeit nicht mehr einloggen koennen.\n"
          +"Wenn Du wieder spielen willst, musst Du Dich an einen Gott oder\n"
          +"Erzmagier wenden (mit einem Gast oder Mail von aussen).\n" );
  else {
    write( "Die Spielpause ist aufgehoben.\n" );
    __MASTER_OBJECT__->TBanishName(getuid(this_object()), 0);
    return 1;
  }
  write( "Wenn Du das wirklich willst, gib jetzt 'ja' ein.\n]" );
  input_to( "spielpause2", 0, days);
  return 1;
}

static void spielpause2(string str, int days)
{
  if (str && (str == "ja" || str == "Ja" || str == "JA")) {
    __MASTER_OBJECT__->TBanishName(getuid(this_object()), days);
    write(
      "Ok, die Spielpause wird mit dem naechsten Ausloggen wirksam.\n"
      "Solltest Du es Dir bis dahin noch einmal ueberlegt haben, so kannst\n"
      "Du den Vorgang mit 'spielpause 0 tage' wieder rueckgaengig machen.\n");
    return;
  }
  write("Vorgang wurde abgebrochen.\n" );
}

/*
 *-----------------------------------------------------------------
 * Aenderung das Passwords
 *-----------------------------------------------------------------
 */
static int change_password() {
  string verb;
  verb=query_verb();
  if (verb!="passwd"&&verb!="password"&&verb!="passwort")
    return 0;
  write("Bitte das ALTE Passwort angeben: ");
  input_to("change_password2",1);
  return 1;
}

static int change_password2(string str) {
  write("\n");
  if (!str) {
    str == "";
  }
  if (MASTER->update_password(str,str) == 0) {
    write("Falsches Passwort!\n");
    return 1;
  }
  passwold = str;
  write("Bitte das NEUE Passwort eingeben: ");
  input_to("change_password3",1);
  return 1;
}

static int change_password3(string str) {
  write("\n");
  if ((!str) || str == "") {
    write("Abgebrochen !\n");
    return 1;
  }
  if (lower_case(str)==getuid())
  {
    write("Das ist zu leicht zu erraten. Nimm ein anderes, bitte.\n");
    write("Bitte das NEUE Passwort eingeben: ");
    input_to("change_password3",1);
    return 1;
  }
  if (strlen(str) < 6) {
    write("Das neue Passwort muss mindestens 6 Zeichen lang sein !\n");
    write("Bitte das NEUE Passwort eingeben: ");
    input_to("change_password3",1);
    return 1;
  }
  passw = str;
  write("Nochmal: ");
  input_to("change_password4",1);
  return 1;
}

static int change_password4(string str) {
  write("\n");
  if (!str || str != passw) {
    write("Das war verschieden! Passwort NICHT geaendert.\n");
    return 1;
  }
  if (MASTER->update_password(passwold,passw))
    write("Passwort geaendert.\n");
  return 1;
}

/*
 *-----------------------------------------------------------------
 * Rueckmeldungen von Spielern an Magier
 *-----------------------------------------------------------------
 */
static int bug(string str) {
  if (!(str=_unparsed_args())) {
    write( "Wie sieht der Fehler denn aus?\n]" );
    input_to("bug2");
    return 1;
  }
  write("Vielen Dank fuer die Hilfe.\n");
  smart_log("BUG",str);
  return 1;
}

static int bug2(string str) {
  if (!str || str == "") {
    write("Bug abgebrochen...\n");
    return 1;
  }
  write("Vielen Dank fuer die Hilfe.\n");
  smart_log("BUG",str);
  return 1;
}

static int typo(string str) {
  if (!(str=_unparsed_args())) {
    write( "Wo ist denn der Tippfehler?\n]" );
    input_to("typo2");
    return 1;
  }
  write("Vielen Dank fuer die Hilfe.\n");
  smart_log("TYPO",str);
  return 1;
}

static int typo2(string str) {
  if (!str || str == "") {
    write("Typo abgebrochen...\n");
    return 1;
  }
  smart_log("TYPO",str);
  write("Vielen Dank fuer die Hilfe.\n");
  return 1;
}

static int epidea(string str) {
  if (!(str=_unparsed_args())) {
    write( "Was fuer eine Idee fuer einen Forscherpunkt hast Du denn?\n]" );
    input_to("epidea2");
    return 1;
  }
  write("Vielen Dank fuer die Hilfe.\n");
  smart_log("EP",str);
  return 1;
}

static int epidea2(string str) {
  if (!str || str == "") {
    write("EP-Idee abgebrochen...\n");
    return 1;
  }
  write("Vielen Dank fuer die Hilfe.\n");
  smart_log("EP",str);
  return 1;
}

static int idea(string str) {
  if (!(str=_unparsed_args())) {
    write( "Was fuer eine Idee hast Du denn?\n]" );
    input_to("idea2");
    return 1;
  }
  write("Vielen Dank fuer die Hilfe.\n");
  smart_log("IDEA",str);
  return 1;
}
static int idea2(string str) {
  if (!str || str == "") {
    write("Idee abgebrochen...\n");
    return 1;
  }
  write("Vielen Dank fuer die Hilfe.\n");
  smart_log("IDEA",str);
  return 1;
}

static int detail(string str) {
  if (!(str=_unparsed_args())) {
    write( "Was fuer ein Detail fehlt denn?\n]" );
    input_to("detail2");
    return 1;
  }
  write("Vielen Dank fuer die Hilfe.\n");
  smart_log("DETAIL",str);
  return 1;
}
static int detail2(string str) {
  if (!str || str == "") {
    write("Detail abgebrochen...\n");
    return 1;
  }
  write("Vielen Dank fuer die Hilfe.\n");
  smart_log("DETAIL",str);
  return 1;
}

static void smart_log(string myname, string str)
{
  string creat, creat2, date, filext, filext2, obnam, rest;
  object obj;
  string *strs;
 
  if (sscanf(str,"%s:%s",obnam,rest)==2 && 
      ((obj=present(obnam,environment())) || (obj=present(obnam)) ))
    str = rest;
  else {
    obj = QueryProp(P_REFERENCE_OBJECT);
    if (!obj || !present(obj))
      obj = environment(this_interactive());
  }

  creat = MASTER->creator_file(obj);
  strs= MASTER->full_path_array(file_name(obj),0);
  if( strs[0]=="d" && myname!="EP" )
    creat2 = strs[1]+"/"+creat;

  date = dtime(time())[5..<11];
  if (creat == ROOTID)
    creat = "ROOT";
  else if( !creat || creat[0]==' ' )
    creat="STD";
  switch(myname)
  {
    case "EP":     filext = ".ep";   break;
    case "DETAIL": filext = ".rep"; filext2 = ".det";  break;
    case "IDEA":   filext = ".rep"; filext2 = ".idea"; break;
    case "BUG":    filext = ".rep"; filext2 = ".bug";  break;
    case "TYPO":   filext = ".rep"; filext2 = ".typo"; break;
    default:       filext = ".rep";  break;
  }
  creat = "report/" + creat + filext;
  // FP-Vorschlaege NICHT in Objekt-Logfiles
  if ((myname=="EP") || !obj->SmartLog(creat, myname, str, date)) {
    log_file( creat, myname + " von " + capitalize(getuid(this_interactive()))
              + " [" + file_name(obj) + "] (" + date + "):\n" );
    log_file( creat, str + "\n\n" );
    if(creat2)
    {
      creat2="report/"+creat2+filext2;
      log_file( creat2, capitalize(getuid(this_interactive()))
              + " [" + file_name(obj) + "] (" + date + "):\n" );
      log_file( creat2, str + "\n\n" );
    }
  }
  // Die globalen logs wurden ausgebaut, da sie ja eh' niemand liest.
}

static int _quit()
{
  int arg;
  Set(P_LAST_LOGOUT,time());
  if( sscanf( getuid(), "gast%d", arg) != 1 )
  {
    write("Speichere "+QueryProp(P_NAME)+".\n");
    save_me(0);
  }
  catch(VOICEMASTER->RemoveUser(ME));
  if (environment()) {
    catch(environment()->PlayerQuit(ME));
    catch(map_objects(deep_inventory(ME)+all_inventory(environment()),
                      "PlayerQuit", ME));
  }
  if (catch(remove())) destruct(ME);
  return 1;
}

int quit()
{
  return _quit();
}

static int new_quit()
{
  mixed x;
  if (IS_LEARNING(ME)) return quit();
  if (environment() && (x=environment()->QueryProp(P_NOQUIT))) {
    if (stringp(x))
      write(x);
    else
      write("Es ist an diesem Ort nicht moeglich, das Spiel zu verlassen.\n");
    return 1;
  }
  if (ME->EnemyPresent())  // && (time()-QueryProp(P_LAST_QUIT)<600))
  {
    write ("Du bereitest Dich"+
        (find_call_out("quit") != -1 ? " erneut" : "")+
        " auf den Ausstieg aus dem Spiel vor.\n");
    remove_call_out("quit");
    call_out("quit", 10);
    return 1;
  }
  if (QueryProp(P_NEXT_SPELL_TIME)+30 > time())
  {
    write ("Du bist noch zu erschoepft von Deinem letzten Zauberspruch.\n");
    return 1;
  }
  return quit();
}

static string exhausted_text()
{
  int p;
  p = 100 * QueryProp(P_MV) / QueryProp(P_MAX_MV);
  switch (p)
  {
    case 0..5:   return "Du bist im Moment schwer erschoepft.";
    case 6..15:  return "Du bist ziemlich ausser Atem.";
    case 16..30: return "Du bist etwas erschoepft.";
    default:     return "";
  }
}

static varargs int score(string arg, int nolastline) {
  mixed ind;

  if (QueryProp(P_GHOST)) {
    write("Im ewigen Leben gibt es keine Punkte.\n");
    return 1;
  }
  ind=QueryProp(P_ATTRIBUTES);
  write(sprintf(
    "Du bist: %s\n"+
    "+------------------------------+------------------------------+\n"
    "| Erfahrungspunkte:  %9d | Lebenspunkte:      %3d (%3d) |\n"
    "| Abenteuerpunkte: %4d (%4d) | Magiepunkte:       %3d (%3d) |\n"
    "| Stufenpunkte:          %5d | Attributpunkte:           %2d |\n"
    "+------------------------------+------------------------------+\n"
    "| Intelligenz:        %8s | Ausdauer:           %8s |\n"
    "| Geschicklichkeit:   %8s | Kraft:              %8s |\n"+
    (nolastline ? "" :
    "+------------------------------+------------------------------+\n"
    ),
    capitalize(implode(explode(short()||"", "\n"), "")),
    QueryProp(P_XP), QueryProp(P_HP), QueryProp(P_MAX_HP),
    QueryProp(P_QP), QM->QueryMaxQP(),
    QueryProp(P_SP), QueryProp(P_MAX_SP),
    QueryProp(P_LP), QueryProp(P_AP),
    sprintf("%d (%+d)", ind[A_INT], QueryAttributeOffset(A_INT)),
    sprintf("%d (%+d)", ind[A_CON], QueryAttributeOffset(A_CON)),
    sprintf("%d (%+d)", ind[A_DEX], QueryAttributeOffset(A_DEX)),
    sprintf("%d (%+d)", ind[A_STR], QueryAttributeOffset(A_STR))
  ));
  return 1;
}

static int info(string arg) {
  string gift, tmp, stra;   // stra und g  by Querolin
  int i,sz,val,g;
  mixed ind;
  object *enem1, *enem2, *inv;

  if (QueryProp(P_GHOST)) {
    write("Im ewigen Leben gibt es keine Punkte.\n");
    return 1;
  }
  if (val=QueryProp(P_POISON)) {
    gift="| Du bist ";
    gift+=(val<4 ? "leicht vergiftet." : "vergiftet!       ");
    gift+="                                   |\n";
  } else
    gift="";
  if ((tmp=exhausted_text()) != "")
    gift+=sprintf("| %-59s |\n", tmp);

  score(arg, 1);
  stra="";
  g = 100 * (QueryProp(P_TOTAL_WEIGHT) - QueryProp(P_WEIGHT) + 1 )
          / QueryProp(P_MAX_WEIGHT);
  switch (g)
  {
    case 0..64:
      stra="";
      break;
    case 65..70: 
      stra="| Langsam beginnt Dein Gepaeck Dir Muehe zu machen.           |\n";
      break;
    case 71..80: 
      stra="| Du schleppst schon sehr viel mit Dir herum.                 |\n";
      break;
    case 81..90: 
      stra="| Du bist schon schwer beladen.                               |\n";
      break;
    case 91..95: 
      stra="| Viel wirst Du nicht mehr tragen koennen.                    |\n";
      break;
    case 96..99: 
      stra="| Du bist beinahe schon ueberladen.                           |\n"; 
      break;
    case 100:
    default: 
      stra="| Du kannst absolut nichts mehr tragen.                       |\n";
  }

 write(sprintf(
    "+------------------------+-----+-----------+------------------+\n"
    "| Gilde: %:-15s | Gildenlevel: %2d | Spielerlevel: %2d |\n"
    "+------------------------+-----------------+------------------+\n"+
    gift+stra+
    "| Vorsicht-Modus: %3d%:-40s |\n"
    "| Dein Charakter ist %-40s |\n"
    "| Alter: %-52s |\n%s"
    "+-------------------------------------------------------------+\n"
    ,
    (QueryProp(P_GUILD) ?
      capitalize(QueryProp(P_GUILD)) :
      capitalize(QueryProp(P_DEFAULT_GUILD) || DEFAULT_GUILD)),
    QueryProp(P_GUILD_LEVEL) ? QueryProp(P_GUILD_LEVEL) : QueryProp(P_LEVEL), 
    QueryProp(P_LEVEL),
    QueryProp(P_WIMPY),
    (QueryProp(P_WIMPY_DIRECTION) ?
      ", Fluchtrichtung: "+to_string(QueryProp(P_WIMPY_DIRECTION)) :
      ""),
    al_to_title(QueryProp(P_ALIGN))+".",
    get_age(),
    (QueryProp(P_AWAY) ?
      sprintf("| Du bist nicht ansprechbar: %:-32s |\n",
              QueryProp(P_AWAY)) : "")
    ));

  ind = explode(break_string(Forschung(), 59), "\n");
  for (i=0;i<sizeof(ind);i++)
    write(sprintf("| %-59s |\n", to_string(ind[i])));
  write("+-------------------------------------------------------------+\n");

  enem1=((mixed)QueryEnemies())[0];
  if (!sizeof(enem1)) return 1;
  enem2=({});
  inv=all_inventory(environment(ME));
  for (i=0;i<sizeof(enem1);i++)
    if (member_array(enem1[i],inv)==-1) // Ist unser Feind und ist nicht hier 
      enem2+=({enem1[i]});
  if (!sizeof(enem2)) return 1;
  ind = explode( break_string(
    "Du verfolgst "+CountUp( map_objects( enem2, "name", WEN ) )
    +".", 59), "\n");
  for (i=0;i<sizeof(ind);i++)
    write(sprintf("| %-59s |\n", to_string(ind[i])));
  write("+-------------------------------------------------------------+\n");
  return 1;
}

static string getmanpage(string dir, string page)
{
  string text, *syn;
  int i;

  if (dir[<1] != '/')
    dir += "/";

  if ((text=read_file(dir+page)) && strlen(text))
    return text;

  if (text = read_file(dir+".synonym")) {
    syn = regexplode(text, "([ \t][ \t]*|\n)");
    if ((i=member(syn, page))!=-1)
      return read_file(dir+syn[i+2]);
  }
  return 0;
}

static int help(string str)
{
  string verb, rest, text;
  mixed found;

  found=0;
  text = "";
  if (str)
  {
    str = implode( explode(str, ".." ), "");
    if ( sscanf( str, "%s %s",verb,rest )==2 ) str = verb;
    
    if ((IS_LEARNER(PL)) ) {
      if (rest = getmanpage("/doc/w/",str)) {
	found = 1;
	text += rest;
      }
    }

    if ((IS_SEER(PL)) /*&& !found*/ ) {
      if (rest = getmanpage("/doc/s/",str)) {
	if (found)
	  text += "\n----------------\n";
	else
	  found = 1;
	text += rest;
      }
    }

    if (rest = getmanpage("/doc/helpdir/",str)) {
      if (found)
	text += "\n----------------\n";
      else
	found = 1;
      text += rest;
    }
    if (!found)
      text = "Dazu ist keine Hilfe verfuegbar.\n";

   More(text,0);
   return 1;
  }
  if (IS_LEARNER(PL))
    text = read_file("/doc/magier_hilfe");
  else if (IS_SEER(PL))
    text = read_file("/doc/seher_hilfe");

  More(text + read_file("/doc/help"), 0);
  return 1;
}

static mixed PlayerMore()
{
  return More("/doc/help",1);
}

public mixed filter_who_options(string str)
{
  string par;
  string* opt;
  int i, j, len, res;

  opt = explode(str," "); len=sizeof(opt);
  res = 0;
  par = "";
  for (i=0; i<len; i++)
    switch (opt[i])
    {
      case "short":
      case "-kurz":
        res |= 1;
        par += " short";
        break;
      case "vert":
      case "-vertikal":
        res |= 3;
        break;
      case "alpha":
      case "-alpha":
      case "-alphabetisch":
        res |= 4;
        break;
      default:
        if (opt[i][0] == '-')
          for (j=strlen(opt[i])-1; j; j--)
            switch (opt[i][j])
            {
              case 'a': res|=4; par += " alpha"; break;
              case 'k': res|=1; par += " short"; break;
              case 'v': res|=3; par += " vert"; break;
            }
        else if (i)
          return ({ res, implode(opt[i..]," "), par[1..] });
        else
          return ({ 0, str, "" });
    }
  return ({ res, 0, par[1..] });
}

static int who(string str)
{
  int i, shrt;
  string res, ret, params, mud;
  mixed ans;

  if (str = _unparsed_args())
  {
    ans = filter_who_options(str);
    shrt = ans[0];
    str = ans[1];
    params = ans[2];
  }
  if (stringp(str) && strlen(str))
  {
    ans = explode(str, " ");
    mud = ans[0];
    ans = ans[1..];
    if (mud == "mud" && sizeof(ans)) {      // Wird explizit nach einem
      mud = ans[0]; ans = ans[1..]; i=1;    // anderen Mud gefragt?
    } else i=0;
    params = implode(explode(params, " ") + ans - ({""}), " ");
    if (sizeof(INETD->expand_mud_name(mud)) || i)
    {
      if (ret=INETD->send_udp(mud,
			      ([ REQUEST: "who",
                                 SENDER:  getuid(ME),
                                 DATA:    params ]), 1 ))
	write(ret);
      else
	write("Anfrage abgeschickt.\n");
      return 1;
    }
  }

  // altes Format... Altlast -> raus.
  // if (str) i=(member(str,'o')>0); else i=0;

  res = implode("/obj/werliste"->QueryWhoListe(
      IS_LEARNER(ME) && QueryProp(P_WANTS_TO_LEARN),shrt,0,str), "\n");

  if (shrt & 1)
    ret = res + "\n\n";
  else
  {
    ret = "---------------------------------------"+
          "---------------------------------------\n";
    ret = "Liste der Mitspieler vom " + dtime(time()) + " ("+
          sizeof(explode(res,"\n")-({""})) + " Teilnehmer):\n" + ret + res +
          (strlen(res) ? "\n"+ret : "");
  }
  More(ret,0);
  return 1;
}

static int kwho(string str)
{
  int shrt;
  mixed res;
 
  if(str) {
    res = filter_who_options(str);
    shrt = res[0];
    str = res[1];
  }
  More(implode( "/obj/werliste"->QueryWhoListe(IS_LEARNER(ME) && QueryProp(P_WANTS_TO_LEARN), shrt|1 ,0, str),"\n")+"\n\n",0);
  return 1;
}

static varargs int kkwho(string str) {
  object *obs;
  string *namen,res;
  int i;
  
  obs=filter_users(str);namen=({});
  if (IS_LEARNER(this_player())) {
    for (i=sizeof(obs)-1;i>=0;i--)
      if (environment(obs[i]))
	namen+=({capitalize(geteuid(obs[i]))});
  } else {
    for (i=sizeof(obs)-1;i>=0;i--)
      if (!obs[i]->QueryProp(P_INVIS) && environment(obs[i]))
	namen+=({capitalize(geteuid(obs[i]))});
  }
  namen=sort_array(namen,#'<); //')
  res="";
  for (i=sizeof(namen)-1;i>=0;i--) {
    res+=namen[i];
    if (i)
      res+=", ";
  }
  res+=".";
  write(break_string(res,75));
  
  return 1;
}

static int kill(string str) {
  object eob,wob;
  int i;
  
  if (QueryProp(P_GHOST))
  {
    write("Das kannst Du in Deinem immateriellen Zustand nicht.\n");
    return 1;
  }
  if (QueryGuest())
  {
    write("Du bist doch nur Gast hier.\n");
    return 1;
  }
  if (!str || str == "") {
    write("WEN willst Du toeten?\n");
    return 1;
  }
  eob = present(lower_case(str),environment(PL));
  if (!eob || !living(eob)) {
    if (str=="alle") {
      object *lvs;
      lvs=filter_array(all_inventory(environment(PL)),
		       lambda(({'x}),({#'?,
			 ({#'query_once_interactive, 'x}), ({#'return, 0}),
			 ({#'living, 'x}), ({#'return, 1}), 
				({#'return, 0})}))); // '})})));
      if (i=sizeof(lvs)) {
	for (i--;i>=0;i--)
          if ((!lvs[i]->QueryProp(P_NO_GLOBAL_ATTACK)) &&
              (!lvs[i]->QueryProp(P_FRIEND)))
            Kill(lvs[i]);
	return 1;
      }
    }
    write("Du siehst hier kein derartiges Wesen!\n");
    return 1;
  }
  if (eob == PL)
  {
    write("Selbstmord ist keine Loesung!\n");
    return 1;
  }
  /* Kill him */
  Kill(eob);
  return 1;
}

static int stop(string str)
{
  if (!str)
  {
    StopHuntingMode();
    write("Ok.\n");
    return 1;
  }
  if (!StopHuntFor(str)) write("So jemanden verfolgst Du nicht!\n");
  return 1;
}

int emote(string str,int genitiv)
{
  string *commands,message,verb;
  object living;
  int i,size;

  if (!(Query(P_CAN_FLAGS)&CAN_EMOTE)) return 0;
  if (query_verb()[0]==';'||query_verb()[0..5]=="gemote") genitiv=1;
  if (query_verb()[0]==':'||query_verb()[0]==';')
    verb=query_verb()[1..]+" ";
  else
    verb="";
  str=this_player()->_unparsed_args();
  commands=explode(verb+(str||""),"#");
  message=
    break_string((IS_SEER(ME) ? "" : ">")
      +capitalize(genitiv ? name(WESSEN) : name())
      +" "+commands[0],78);
  size=sizeof(commands);
  if(size>=3)
  {
    living=find_living(lower_case(commands[1])); 
    if(!living || environment(living)!=environment())
    {
      write(capitalize(commands[1])+" sehe ich hier nicht!\n");
      return 1;
    }
    if (living != ME)
      tell_object(living,break_string((IS_SEER(this_player()) ? "" : ">")
				   +(genitiv ? this_player()->Name(WESSEN) : 
					       this_player()->Name())
				   +" "+commands[2],78));
  }
  if(size>=4)
    write(break_string(commands[3],78));
  else
    write(message);
  tell_room(environment(),message,({this_object(),living}));
  return 1;
}

static int remote(string str, int flag)
{
  string verb, dest, message;
  string *exstr, *parts;
  int size, m;
  object destpl;

  if (!(Query(P_CAN_FLAGS)&CAN_REMOTE)) return 0;
  if(!IS_LEARNER(ME))
  {
    if (QueryProp(P_QP) < QM->QueryMaxQP()) return 0;
  }
  if (!(str=_unparsed_args())||sizeof(exstr=explode(str," ")-({}))<=1)
  {
    write("Was willst Du zu wem `emoten`?\n");
    return 1;
  }
  dest = exstr[0];
  str = implode(exstr[1..]," ");
  verb = query_verb();
  if(!(destpl=find_player(match_living(dest)))||(destpl->QueryProp(P_INVIS)&&
				   !IS_LEARNER(ME)))
  {
    write("Einen solchen Spieler gibt es derzeit nicht.\n");
    return 1;
  } 
  if (destpl == ME)
  {
    write("Bist Du wirklich so weit von Dir entfernt?\n");
    return 1;
  }
  if (environment() == environment(destpl))
  {
    write("Innerhalb eines Raumes solltest Du "+verb[1..]+
      " benutzen.\n");
    return 1;
  }
  message = (flag ? Name(WESSEN) : Name(WER));
  size = sizeof(parts = explode(" "+str, "#"));
  if ( size == 1 )
    message +=  parts[0] + " aus der Ferne.\n";
  else
    if ( size == 2)
      message += parts[0] + "aus der Ferne" + parts[1] + ".\n";
    else
    {
      write("Syntax: "+verb+" <name> <text>\n"+
            "oder:   "+verb+" <name> <text1> # <text2>\n");
      return 1;
    }
  if (m=destpl->Message(message, MSGFLAG_REMOTE) > 0)
    write(break_string(destpl->Name()+"->"+message, 78));
  else if (m == MESSAGE_CACHE)
    write(destpl->Name()+" ist gerade beschaeftigt.\n");
  else if (m == MESSAGE_IGNORE_YOU)
    write(destpl->Name()+" ignoriert Dich.\n");
  else
    write(destpl->Name()+" ignoriert Deine Meldung.\n");
  return 1;
}

static int gemote(string str) 
{
  return emote(str, 1);
}

static int rgemote(string str) 
{
  return remote(str, 1);
}

static void load_auto_objects(mapping map);

static int move_player_to_start(string where);
static void move_player_to_start2(string where);
static void move_player_to_start3(string where);

static void updates_after_restore() {
  attributes::update_max_sp_and_hp();
}

varargs nomask int start_player(string str, string ip)
{
  int newflag;  /* could player be restored? */
  string str1, str2;

  str1=explode(file_name(previous_object()),"#")[0];
  if ((str1 != "/secure/login") &&
      (str1 != "/secure/master") &&
      (!geteuid(ME) ||
       geteuid(ME) != getuid(ME) ||
       capitalize(geteuid(ME)) != str ||
       geteuid(ME) != geteuid(previous_object())))
  {
    write("DIESER VERSUCH WAR ILLEGAL !!\n");
    destruct(ME);
    return 0;
  }
  /* autosave the player after 500 heartbeats */
  time_to_save = 500;
  my_ip=ip;
  /* try to restore player. If it doesn't exist, set the new flag */
  Set(P_WIMPY, 20);

  newflag = !restore_object("/"+SAVEPATH+lower_case(str)[0..0]+"/"
			    +lower_case(str));

  updates_after_restore();
  if(query_once_interactive(ME))
    Set(P_LAST_LOGIN,time());
//  Set(P_WANTS_TO_LEARN,1); // 1 sollte der default sein !!!
//  15.1.98: Nachdem die Flags fuer Magier ne Bedeutung haben,
//  sollte man das Ding hier auch wirklich mit dem urspruenglichen
//  Wert nehmen.  -Crea-
  Set(P_WANTS_TO_LEARN,PROTECTED,F_MODE_AS);
  if(!QueryProp(P_CAN_FLAGS))
  { SetProp(P_CAN_FLAGS, CAN_EMOTE); }
  if(IS_SEER(ME))
    SetProp(P_CAN_FLAGS,QueryProp(P_CAN_FLAGS)|CAN_REMOTE);
  Set(P_NAME, str);
  Set(P_NAME, SECURED, F_MODE_AS);
  if(!QueryProp(P_NEEDED_QP))
    SetProp(P_NEEDED_QP,QM->QueryNeededQP());
  Set(P_NEEDED_QP,-1,F_SET_METHOD);
  Set(P_NEEDED_QP,SAVE|SECURED,F_MODE_AS);
  time_to_save = age + 500;
  potion::create(); /* DO IT HERE AFTER THE RESTORE !! */
  AddId(getuid());
  SetProp(P_AC,0);
  SetProp(P_WEAPON,0);
  /* Set some things which wont be set when all is OK */
  SetProp(P_MAX_HP, ((int)QueryAttribute(A_CON))*8+42);
  SetProp(P_MAX_SP, ((int)QueryAttribute(A_INT))*8+42);

  call_out("delayed_notify",3,getuid(ME));
  
  /* If this is a new character, we call the adventurers guild to get
   * our first title !
   */
  if (!newflag) {
    move_player_to_start(0);
  }
  else {
    int arg;
    // if ( sscanf(getuid(),"gast%d",arg) == 1 )
    //   SetProp(P_TITLE,"durchstreift das "+MUDNAME+" ...");
    funcall(#'Set, P_LEVEL, -1 /*'*/);
    SetProp(P_ATTRIBUTES,([A_STR:1,A_CON:1,A_INT:1,A_DEX:1]));
    SetProp(P_HP, QueryProp(P_MAX_HP));
    if (IS_WIZARD(ME))
      set_is_wizard(ME,1);
    else
      set_is_wizard(ME,0);
    move_player_to_start(0);
  }
  catch(bb="/secure/bbmaster"->query_bb());
}

static void delayed_notify(string wer)
{
  int i;

  if (!find_player(wer))
  {
  /* Leider werden wenn die Login Sequenz zu lange dauert die Spieler
     nicht von Merlin gefunden... drum hier ein workaround, welches
     zumindest 5 Chancen gibt...
     Dass es hier zu Ueberschneidungen kommen kann ist mir bewusst, 
     aber selbst fuer das sollten 5 Chancen reichen... 
     zumindest bist mir was bessers eingefallen ist :)
     Leider aber weiss noch nicht genau warum der player noch nicht
     existiert (oder per find_player() gefunden wird), und darum hoffe
     ich mal das Problem so zu fixen...
     Querolin 2002.02.14
  */
    i++;
    if (i<5) 
    {
      call_out("delayed_notify",1+i,wer);
      return;
  } }
  i=0;
//  if (find_player("querolin")) { tell_object(find_player("querolin"),
//      break_string(
//       wer+" in delayed_notify() in /std/player/base.c aufgerufen.\n",78) ); }

  catch("/secure/merlin"->notify_player_enter(wer));
}

static int move_player_to_start4(string where)
{
  int num;
  string err;
  string called_from_ip, called_from_ip_name;
  mixed start_place;

  if (QueryProp(P_LEVEL) == -1)
  {
    int arg;
    funcall(#'Set, P_LEVEL, 0 /*'*/);
//    catch("/std/gilde"->advance("stufe"));
    if (sscanf(getuid(),"gast%d",arg) == 1)
      SetProp(P_TITLE,"durchstreift das "+MUDNAME+"...");
    // else if (Query(P_GENDER)==FEMALE)
    //   Set(P_TITLE,"die hoffnungsvolle Anfaengerin");
    // if ((Query(P_GENDER)==FEMALE) && !sscanf(getuid(),"gast%d",arg))
    //   Set(P_TITLE,"die hoffnungsvolle Anfaengerin");
    funcall(#'Set, P_LEVEL, 1 /*'*/);
  }

  enable_commands();

  set_heart_beat(1);
  command::initialize();
  add_put_and_get_commands();
  add_soul_commands();
  add_action("UseSpell","",1);
  if (interactive(this_object()))
  {
    if (IS_WIZARD(this_object()))
      cat("/etc/WIZNEWS");
    else
      cat("/etc/NEWS");
    if (query_ip_number(ME)=="128.130.45.201")
      cat("/etc/NEWS.atpforest");
    if (QueryProp(P_INVIS) && !IS_WIZARD(PL)) SetProp(P_INVIS,0);
    if (num="secure/mailer"->FingerMail(getuid()))
      write("  __ /\n"
            " |__|   Du hast "+num+" neue"+(num==1 ? "n Brief" : " Briefe")+
            " im Postamt liegen.\n\n");
    catch(VOICEMASTER->RegisterUser(ME));
    // printf("%O:%O\n",ME,query_ip_name());
    called_from_ip = QueryProp(P_CALLED_FROM_IP);
    called_from_ip_name = QueryProp(P_CALLED_FROM_IP_NAME);
    if ((called_from_ip || called_from_ip_name) &&
        (query_ip_number() != called_from_ip))
      write(sprintf("Das letzte Mal kamst Du von %s (%s)\n",
        (called_from_ip_name || "unbekannt"),
        (called_from_ip || "unbekannt")));
    funcall(#'Set, P_CALLED_FROM_IP, query_ip_number()); //');
    funcall(#'Set, P_CALLED_FROM_IP_NAME, query_ip_name(ME)); //');
  }
  set_living_name(getuid());
  if (!stringp(default_home) || default_home=="") 
    default_home="gilden/abenteurer";
  err=0;
  // Keine autom. Seherhaeuser im SL!!!
  /*
  if (IS_SEER(ME) && !IS_LEARNER(ME))
    start_place=HAUSVERWALTER->FindeHaus(getuid(ME));
  else
    start_place=0;
  if (!start_place)
    start_place=QueryProp(P_START_HOME);
  */
  start_place=QueryProp(P_START_HOME);
  if (start_place && (objectp(start_place)
                      || (stringp(start_place) && start_place != "")))
  {
    if ((err=catch(move(start_place, M_GO|M_NOCHECK|M_SILENT|M_NO_SHOW)))
        || !environment())
      err=catch(move(default_home, M_GO|M_NOCHECK|M_SILENT|M_NO_SHOW));
  }
  else 
    err=catch(move(default_home,M_GO|M_NOCHECK|M_SILENT|M_NO_SHOW));
  if (err) catch(move("gilden/abenteurer",M_GO|M_NOCHECK|M_SILENT|M_NO_SHOW));
  catch(ME->FinalSetup());
  load_auto_objects(autoload);
  AddMoney(ndead_lasttime);
  ndead_lasttime=0;
  if (!QueryProp(P_INVIS)) say(capitalize(name(WER)) + " betritt diese Welt.\n");
  else write("DU BIST UNSICHTBAR!\n\n");

  /*
  if (query_mud_port(this_player())==4711)
    write("...");
  */
  if (IS_WIZARD(getuid(ME)))
    set_is_wizard(ME,1);
  else
    set_is_wizard(ME,0);
  {
    string *list;
    object ob;
    int i,mag;

    list=QueryProp(P_WAITFOR);
    mag=IS_LEARNER(ME);
    for (i=sizeof(list)-1;i>=0;i--)
      if (!(ob=find_player(lower_case(list[i]))) || 
          (!mag && IS_LEARNER(ob) && ob->QueryProp(P_INVIS)))
	list=list[0..i-1]+list[i+1..];
    if (sizeof(list))
      write(break_string("Anwesende Erwartete: "+CountUp(list)+".", 78));
  }
  save_me(1);   // nach erfolgter Initialisierung abspeichern
}


/*
 * Checks for several player info:
 * - email address
 * - gender
 * - terminal
 */
static int move_player_to_start(string where) {
  string mailaddr;

  if (QueryProp(P_CARRIED_VALUE) > 0)
  {
    ndead_lasttime = QueryProp(P_CARRIED_VALUE);
    write("Du findest "+ndead_lasttime
         +" Muenzen, die Du beim letzten Mal verloren hast.\n");
    SetProp(P_CARRIED_VALUE, 0);
  }
  if (file_time("/save/"+getuid()[0..0]+"/"+getuid()+".o") <
      last_reboot_time()) {
    SetProp(P_FOOD, 0);
    SetProp(P_DRINK, 0);
    SetProp(P_ALCOHOL, 0);
    SetProp(P_POISON, 0);
    SetProp(P_MV, QueryProp(P_MAX_MV));
  }
  if (!(mailaddr = Query(P_MAILADDR)) || mailaddr == "")
  {
    write("Gib bitte Deine E-Mail Adresse an (oder 'none'): ");
    saved_where = where;
    input_to("getmailaddr");
    return 0;
  }
  move_player_to_start2(where);
}
static void getmailaddr(string maddr) {
  if (!stringp(maddr) || !strlen(maddr))
    maddr = "none";
  Set(P_MAILADDR, maddr);
  move_player_to_start2(saved_where);
}

static void move_player_to_start2(string where) {
  if( member_array( QueryProp(P_GENDER), ({MALE,FEMALE}) ) == -1 )
  {
    write("Bist Du maennlich oder weiblich: ");
    input_to("getgender", 0);
    return;
  }
  move_player_to_start3(where);
}

/*  This function is called using input_to, and sets the
 *  gender of this player.
 */
static void getgender(string gender_string) {

  gender_string = lower_case(gender_string);
  if (gender_string[0] == 'm') {
    write("Willkommen, mein Herr!\n");
    SetProp(P_GENDER,MALE);
  }
  else if (gender_string[0] == 'w') {
    write("Willkommen, gnae' Frau!\n");
    SetProp(P_GENDER,FEMALE);
    SetProp(P_TITLE,"die hoffnungsvolle Anfaengerin");
  }
  else {
    write("Wie? Was? Verstehe ich nicht!\n");
    write("Bist Du maennlich oder weiblich? (tippe m or w): ");
    input_to("getgender");
    return;
  }  
  move_player_to_start3(saved_where);
}

static void move_player_to_start3(string where) {
  if (!QueryProp(P_TTY) || QueryProp(P_TTY) == "none") {
    write("Waehle einen Terminaltyp (kann spaeter mit <stty> geaendert werden)\n");
    write("vt100, ansi, dumb [dumb] ");
    input_to("gettty", 0);
    return;
  }
  move_player_to_start4(where);
}

/*  This function is called using input_to, and sets the
 *  tty of this player.
 */
static void gettty(string ttystr) {
  if (!ttystr || ttystr == "") ttystr = "dumb";
  ttystr = lower_case(ttystr);
  if (ttystr == "vt100") {
    write("Dies sollte "+ANSI_BOLD+"fett"+ANSI_NORMAL+" sein.\n");
    SetProp(P_TTY, ttystr);
  }
  else if (ttystr == "ansi") {
    write("Dies sollte "+ANSI_RED+"rot"+ANSI_NORMAL+" sein.\n");
    SetProp(P_TTY, "ansi");
  }
  else if (ttystr == "dumb") {
    write("Ohje, oede! Besorg Dir ein besseres Terminal!\n");
    SetProp(P_TTY, "dumb");
  }
  else {
    write("Dieser Terminaltyp wird nicht unterstuetzt. Nimm bitte einen aus:\n");
    write("vt100, ansi or dumb (default is dumb): ");
    input_to("gettty");
    return;
  }  
  move_player_to_start4(saved_where);
}

nomask mixed query_real_name() {
  /* ACHTUNG !! DIES LFUN DARF NICHT ENTFERNT WERDEN !!! */
  /* Sie wird vom Gamedriver (zB bei F_ED) aufgerufen !! */
  return getuid();
}

/*
 * the wizard command review: show player moving messages
 */
int review() {
  string *msg;
  write(short());
  write("Deine Bewegungen werden wie folgt gemeldet:\n"+
        "mout:  "+Name(WER)+" "+(msg=explode(QueryProp(P_MSGOUT),"#"))[0]
       +" <Richtung>"+(sizeof(msg)>1 ? msg[1] : "")+".\n"+
        "min:   "+Name(WER)+" "+QueryProp(P_MSGIN)+".\n"+
        "mmout: "+Name(WER)+" "+QueryProp(P_MMSGOUT)+".\n"+
        "mmin:  "+Name(WER)+" "+QueryProp(P_MMSGIN)+".\n"+
        (IS_LEARNER(ME) ?
	 "cmsg:  "+Name(WER)+" "+QueryProp(P_CLONE_MSG)+".\n"+
	 "dmsg:  <Irgendetwas> "+QueryProp(P_DESTRUCT_MSG)+".\n"
	 : "")+
        "Wenn Du jemanden angreifst, sieht das so aus:\n"+
        Name(WER)+" greift Dich"+QueryProp(P_HANDS)[0]+" an.\n");
  return 1;
}

/*
 * set player moving messages
 */

static int setmin(string str)
{
  if( strlen(_unparsed_args()) > 65 )
  {
    write("Das ist leider zu lange.\n");
    return 1;
  }
  SetProp(P_MSGIN, _unparsed_args()||"kommt an");
  write("min:   "+Name(WER)+" "+QueryProp(P_MSGIN)+".\n");
  return 1;
}

static int setmout(string str)
{
  string *msg;
  if( strlen(_unparsed_args()) > 50 )
  {
    write("Das ist leider zu lange.\n");
    return 1;
  }

  if(sizeof(msg=explode((_unparsed_args()||"geht"),"#"))>2)
  {
    write("Du darfst nur einmal '#' fuer die Richtung angeben.\n");
    return 1;
  }
  if(sizeof(msg)>1)
  {
    if (msg[0]!="" && msg[0][<1]==' ') msg[0]=msg[0][0..<2];
    SetProp(P_MSGOUT, msg[0]+"#"+msg[1]);
  }
  else
    SetProp(P_MSGOUT, _unparsed_args()||"geht");
  write("mout:  "+Name(WER)+" "+(msg=explode(QueryProp(P_MSGOUT),"#"))[0]
       +" <Richtung>"+(sizeof(msg)>1 ? msg[1] : "")+".\n");
  return 1;
}

static int setmmin(string str)
{
  if( strlen(_unparsed_args()) > 65 )
  {
    write("Das ist leider zu lange.\n");
    return 1;
  }
  SetProp(P_MMSGIN, _unparsed_args()||"erscheint");
  write("mmin:  "+Name(WER)+" "+QueryProp(P_MMSGIN)+".\n");
  return 1;
}

static int setmmout(string str)
{
  if( strlen(_unparsed_args()) > 65 )
  {
    write("Das ist leider zu lange.\n");
    return 1;
  }
  SetProp(P_MMSGOUT, _unparsed_args()||"verschwindet");
  write("mmout: "+Name(WER)+" "+QueryProp(P_MMSGOUT)+".\n");
  return 1;
}

static int setcmsg(string str)
{
  SetProp(P_CLONE_MSG, _unparsed_args()||"zaubert etwas aus "
	  + QueryPossPronoun(MALE,WEM) + " Aermel hervor");
  write("Ok.\n");
  return 1;
}

static int setdmsg(string str)
{
  SetProp(P_DESTRUCT_MSG, _unparsed_args()||"wird von " + name(WER,1)
	  + " zerstaeubt");
  write("Ok.\n");
  return 1;
}

static int set_title(string str)
{
  string bonus;
  if( strlen(_unparsed_args()) > 50 )
  {
    write("Das ist leider zu lange.\n");
    return 1;
  }
  if( strlen(_unparsed_args()) + strlen(QueryProp(P_PRESAY)) > 65  )
  {
    write("Zusammen mit Deinem Presay ist das leider zu lange.\n");
    return 1;
  }
  bonus = "";
  if (!(str=_unparsed_args()))
    str = "";
  else if( str[0..1]=="\\b" && str[2]==',')
  {
    bonus = "\b"; // ein backspace fuer ein komma ist ok! :-)
    str = str[2..];
  }
  if (str=="0")
    SetProp(P_TITLE, 0);	// (Gildentitel wird dann angezeigt)
  else
    SetProp(P_TITLE, bonus+str);
  write("Dein Titel lautet jetzt: \""+QueryProp(P_TITLE)+"\".\n");
  write(short());
  return 1;
}

#ifdef NEDIT_FOR_EXTRALOOK

static int done_extralook(string str)
{
  if (!str) {
    write("Ok, abgebrochen.\n");
    return 1;
  }
  if (str=="")
    SetProp(P_EXTRA_LOOK,0);
  else
    SetProp(P_EXTRA_LOOK,str);
  write("Ok.\n");
  return 1;
}

static int extralook(mixed str)
{
  if( str=="?" )
  {
    write( "Dein Extralook ist:\n"+QueryProp(P_EXTRA_LOOK) );
    return 1;
  }
  write("Bitte gib Deinen Extra-Look ein. Hilfe mit ~h. Beenden mit **:\n");
  nedit("done_extralook", QueryProp(P_EXTRA_LOOK));
  return 1;
}

#else

static int extra_input(string str, string look)
{
  if (str=="**" || str==".")
  {
    if (look=="")
      SetProp(P_EXTRA_LOOK,0);
    else
      SetProp(P_EXTRA_LOOK,look);
    write("Ok.\n");
    return 1;
  }
  else if (str=="~h") {
    write("Der Mini-Editor versteht folgende Befehle:\n"
          "~h       Hilfe\n"
          "~r       Zeige gesamten Text an\n"
          "~d       Loesche letzte Zeile\n"
          "~c       Loesche gesamten Text\n"
          "~q       Abbruch\n"
          ". / **   Sauber beenden\n");
  }
  else if (str=="~r") {
    write("Das hast Du bisher geschrieben:\n"+
        "--------------------------\n"+look+
        "--------------------------\n");
  }
  else if (str=="~c") {
    write("Gesamten Text geloescht.\n");
    look="";
  }
  else if (str=="~d") {
    if (strlen(look)) {
      write("Vorherige Zeile geloescht.\n");
      look=implode(efun::explode(look,"\n")[0..<3],"\n");
    }
    else
      write("Du kannst nicht nichts loeschen.\n");
    if (strlen(look)) look+="\n";
  }
  else if (str=="~q") {
    write("Abbruch! Dein Extra-Look bleibt unveraendert.\n");
    return 1;
  }
  else
    look=look+str+"\n";
  write("]");
  input_to("extra_input",0,look);
  return 1;
}

static int extralook(mixed str)
{
  string look;
  look=QueryProp(P_EXTRA_LOOK);
  if (str=="?")
  {
    if (!stringp(look)) write("Du hast keinen Extra-Look.\n");
    else write("Dein Extra-Look ist:\n"+look);
  }
  else if (str=="loeschen") {
    SetProp(P_EXTRA_LOOK,0);
    write("Ok, Extra-Look geloescht.\n");
  } else {
    if (str=="neu") look="";
    write("Bitte gib Deinen Extra-Look ein. Hilfe mit ~h, beenden mit **:\n"+
        (stringp(look) && strlen(look) ?
         "--------------------------\n"+look : "")+"]");
    input_to("extra_input", 0, look || "");
  }
  return 1;
}

#endif

static void calculate_value()
{
  int i, carried_value, value;
  mixed *inv;

  inv=deep_inventory(ME);
  carried_value=0;
  for (i=sizeof(inv)-1;i>=0;i--)
    if (!inv[i]->QueryProp(P_AUTOLOADOBJ))
      carried_value+=((value=inv[i]->QueryProp(P_VALUE))>1000?1000:value);
  SetProp(P_CARRIED_VALUE, carried_value);
}

/* Called by command 'save' */
int save_character() {
  save_me(1);
  write("Ok.\n");
  return 1;
}

void save_me(mixed value_items)
{
  object *obs;
  mixed val;
  string obnam, dummy;
  int i;

  if( getuid()[0..3]=="gast" )
    return;
  autoload=([]);
  obs=deep_inventory(ME);
  for( i=sizeof(obs)-1;i>=0;i--)
  {
    if( val = obs[i]->QueryProp( P_AUTOLOADOBJ ) )
    {
      if( sscanf( file_name( obs[i] ), "%s#%s", obnam, dummy )==2  )
      {
        if (obnam=="/obj/money")
          autoload[obnam] += val;
        else
          autoload += ([obnam:val]);
      }
    }
  }
  if (value_items)
    calculate_value();
  else
    SetProp(P_CARRIED_VALUE, 0);
  // Set(P_LAST_LOGOUT,time());
  catch(call_other(GUILD_DIR+QueryProp(P_GUILD), "GuildRating", this_object()));
  save_object("/"+SAVEPATH+extract(getuid(),0,0)+"/" + getuid());
}

static void load_auto_object(string file,mixed data)
{
  object ob;
  
  ob=find_object(file);
  // if (!ob && file_size("/"+file+".c")<=0)  // Das verhinderte VC-Autoloader
  //   return;
  if (!ob && catch(call_other(file,"???")))
    return;
  if (catch(ob = clone_object(file)))
    return;
  if (catch(ob->move(ME,M_NOCHECK)))
    return;
  if (ob) (void)catch(ob->SetProp(P_AUTOLOADOBJ, data));
}

static void load_auto_objects(mapping map)
{
  mapping to_load; 

  if (!mappingp(map)||!m_sizeof(map)) return;
  to_load=copy_mapping(map);
  walk_mapping(to_load,#'load_auto_object); //');
}

/*
 * al_to_title: Make the numeric alignment value into a string
 
string al_to_title(mixed a)
{
  if (!intp(a)) return "unbekannt";
  if (a >= KILL_NEUTRAL_ALIGNMENT * 1000)
    return "scheinheilig";
  if (a >= KILL_NEUTRAL_ALIGNMENT * 100) 
    return "heilig";
  if (a > KILL_NEUTRAL_ALIGNMENT * 20) 
    return "gut";
  if (a > KILL_NEUTRAL_ALIGNMENT * 4) 
    return "nett";
  if (a > - KILL_NEUTRAL_ALIGNMENT * 4) 
    return "neutral";
  if (a > - KILL_NEUTRAL_ALIGNMENT * 20) 
    return "frech";
  if (a > - KILL_NEUTRAL_ALIGNMENT * 100) 
    return "boese";
  return "satanisch";
}
*/
string al_to_title(mixed a)
{
  if(!intp(a)) return "unbekannt";
  
  /* Korrektur ... al_to_title() wird eh oft genug aufgerufen */
  if(a < -1000) { SetProp(P_ALIGN, -1000); }
  if(a > 1000) { SetProp(P_ALIGN, 1000); }
  
  switch(a)
  {
	case -1000..-951: return "satanisch";
	case  -950..-851: return "daemonisch";
	case  -850..-751: return "teuflisch";
	case  -750..-651: return "grausam";
	case  -650..-551: return "feindselig";
	case  -550..-451: return "boese";
	case  -450..-351: return "mies";
	case  -350..-251: return "gemein";
	case  -250..-151: return "durchtrieben";
	case  -150..-51:  return "verschlagen";
	case   -50..49:   return "neutral";
	case    50..149:  return "umgaenglich";
	case   150..249:  return "nett";
	case   250..349:  return "freundlich";
	case   350..449:  return "aufgeschlossen";
	case   450..549:  return "liebenswuerdig";
	case   550..649:  return "gut";
	case   650..749:  return "nobel";
	case   750..849:  return "ehrenhaft";
	case   850..949:  return "edel";
	case   951..1000: return "heilig";
	default: return "unergruendlich";
  }
}

static int toggle_whimpy_dir(string str) {
  SetProp(P_WIMPY_DIRECTION,str=_unparsed_args()||str);
  if (str)
    printf("Ok, Fluchtrichtung %O.\n",str);
  else
    printf("Ok, bevorzugte Fluchtrichtung deaktiviert.\n");
  return 1;
}

static int toggle_whimpy(string str)
{
  int i;

 /*
    Durch das Folgende Konstrukt ist es Spielern moeglich die Vorsicht
    auch in Prozent einzugeben.
                                 05.01.2001 18:20 Querolin
 */
  if (str)
  {
   if ( (extract(str,1,1)=="%") ||
        (extract(str,2,2)=="%") ||
        (extract(str,3,3)=="%") ||
        (extract(str,4,4)=="%") )
   {
     i=to_int(str);
     if ( (i<0) || (i>100) )
     {
       write("Eingabe muss zwischen 0% und 100% liegen.\n");
       return 1;
     }
     i=((QueryProp(P_MAX_HP)*i) /100);
     str=to_string(i);
   }
   /*
    Wenn eine Eingabe in Prozent erfolgt ist wird hier der umgerechnete
    Wert wieder normal als String weiterverarbeitet ;)
    Net ganz fein aber geht... 
   */
  }

  if(!str || str=="" || (sscanf(str,"%d",i)<0))
  {
    write("Syntax: vorsicht <hp>, wobei gilt: 0 <= hp < "+QueryProp(P_MAX_HP)+
        "\nAktuelle Einstellung: "+
        (QueryProp(P_WIMPY) || "Prinz Eisenherz-Modus")+"\n");
    return 1;
  }
  if ((i<0) || (i>=QueryProp(P_MAX_HP)))
  {
    write("Der Wert ist nicht erlaubt.\n");
    return 1;
  }
  if(!i) write("Prinz Eisenherz-Modus.\n");
  else write("Vorsicht-Modus ("+i+")\n");
  SetProp(P_WIMPY,i);
  return 1;
}

/*
static int where(object ob) 
{
  string ipname;
  TW ("----- where() aufgerufen\n");
  ipname = query_ip_name(ob);
  return (int)(country(lower_case(ipname)));
}
*/

nomask int query_prevent_shadow(object obj)
{
  string what;
  int    dummy;
  
  if (obj){
    what=file_name(obj);
    if (what && what != "" && 
        sscanf(what,"/std/player/shadows/%s#%d",what,dummy)==2)
      return 0;
    // Disabled (security)
    // if (getuid()==getuid(obj) && getuid()==geteuid(obj))
    //   return 0; 
  }
  return 1;
}

/*
 * Force the monster to do a command. The force_us() function isn't
 * always good, because it checks the level of the caller, and this function
 * can be called by a room.
 */
int command_me(string cmd)
{
  if (IS_LEARNER(ME))
  {
    if (!this_interactive() || !previous_object())
      return 0;
    if( geteuid(ME)!=geteuid(this_interactive())
        || geteuid(ME)!=geteuid(previous_object()) )
    {
      if( query_wiz_level(ME)<query_wiz_level(previous_object()))
	tell_object(ME,previous_object()->name()+" zwingt Dich zu: "
		    + cmd + ".\n");
      else
      {
        tell_object(ME,previous_object()->name() 
                    + " versucht, Dich zu " + cmd + " zu zwingen.\n" );
        return 0;
      }
    }
  }
  return command(cmd);
}

static int uhrzeit()
{
  write(dtime(time())+".\n");
  return 1;
}

string SetDefaultHome(string str)
{
  return default_home=str;
}

string SetPrayRoom(string str)
{
  pray_room=str;
}

string QueryPrayRoom()
{
  if (pray_room) return pray_room;
  else return default_home;
}

int _filterattr_con(int i)
{
  if (i<A_MIN) i=A_MIN;
  if (i>A_MAX) i=A_MAX;
  SetProp(P_MAX_HP,42+8*i);
  return i;
}

int _filterattr_int(int i)
{
  if (i<A_MIN) i=A_MIN;
  if (i>A_MAX) i=A_MAX;
  SetProp(P_MAX_SP,42+8*i);
  return i;
}

void _restart_beat()
{
  tell_object(ME, 
    "Der GameDriver teilt Dir mit: Dein Herzschlag hat wieder eingesetzt.\n");
  set_heart_beat(1);
}

static int weg(string str)
{
  if (!(str=_unparsed_args()))
  {
    printf("Du bist nicht%s als abwesend gekennzeichnet.\n", 
           QueryProp(P_AWAY) ? " mehr" : "");
    SetProp(P_AWAY, 0);
    return 1;
  }
  write("Du bist jetzt als abwesend gekennzeichnet.\n");
  SetProp(P_AWAY, str);
  return 1;
}

static void ndead_revive()
{
  string fname;

  set_heart_beat(1);
  ndead_next_check=NETDEAD_CHECK_TIME;
  ndead_currently=0;
  ndead_lasttime=0;
  if (!objectp(ndead_location))
    if (sizeof(explode(ndead_l_filename,"#"))==1)
    {
      catch(call_other(ndead_l_filename,"???"));
      ndead_location=find_object(ndead_l_filename);
    } else
    {
      ndead_location=find_object(ndead_l_filename);
      if (!ndead_location && env_ndead_info)
      {
        fname=explode(ndead_l_filename,"#")[0];
        call_other(fname,"?");
        ndead_location=(find_object(fname)->SetProp(P_NETDEAD_INFO,
                                                    env_ndead_info));
      }
    }       
  if (!ndead_location || catch(move(ndead_location,M_GO|M_NOCHECK)))
  {
    move("gilden/abenteurer",M_GO|M_NOCHECK|M_SILENT);
    catch(move(ndead_location,M_GO|M_NOCHECK,"zurueck ins Leben"));
    ndead_location = environment();
  }
  catch(ndead_location->BecomesNetAlive(ME));
  catch(map_objects(all_inventory(ndead_location) + deep_inventory(ME),
                    "BecomesNetAlive", ME));

  ndead_location=0;
  ndead_l_filename=0;
  env_ndead_info=0;
}

static void ndead_move_me()
{
  set_heart_beat(0);
  stop_heart_beats();
  if (QueryGuest())
  {
    quit();
    if (ME)
      remove();
    if (ME)
      destruct(ME);
    return;
  }
  ndead_next_check=NETDEAD_CHECK_TIME;
  ndead_currently=1;
  ndead_lasttime=0;
  ndead_location=environment();
  if (objectp(ndead_location))
    ndead_l_filename=file_name(ndead_location);
  if (sizeof(explode(file_name(environment()),"#")))
    env_ndead_info=environment()->QueryProp(P_NETDEAD_INFO);
  else
    env_ndead_info=0;
  disable_commands();
  move(NETDEAD_ROOM,M_GO|M_NO_ATTACK|M_NOCHECK,"ins Reich der Netztoten");
}

int QueryGuest()
{
  string dummy;
  return sscanf(getuid(),"gast%d",dummy);
}

int disconnect(string str)
{
  string verb;

  verb=query_verb();
  if (!verb)
    verb="AUTOCALL";
  if (verb[0..5]=="schlaf" && str!="ein")
  {
    notify_fail(
"\"schlafe ein\" beendet Deine Verbindung mit "+MUDNAME+". Du behaeltst Deine"
"\nSachen, aber Vorsicht: Wenn "+MUDNAME+" abstuerzt, waehrend Du weg bist,"
"\nverlierst Du sie doch, genauso, als wenn Du Deine Verbindung mit \"ende\""
"\nbeendet haettest (allerdings bekommst Du dann eine finanzielle "
"Entschaedigung).\n"
"ABER: BENUTZUNG AUF EIGENE GEFAHR !!!\n");
    return 0;
  }
  if (IS_LEARNER(this_object()))
    return quit();
  write(
"Dieser Befehl beendet Deine Verbindung mit "+MUDNAME+". Du behaeltst Deine"
"\nSachen, aber Vorsicht: Wenn "+MUDNAME+" abstuerzt, waehrend Du weg bist,"
"\nverlierst Du sie doch, genauso, als wenn Du Deine Verbindung mit \"ende\""
"\nbeendet haettest (allerdings bekommst Du dann eine finanzielle "
"Entschaedigung).\n"
"ABER: BENUTZUNG AUF EIGENE GEFAHR !!!\n");
  if (is_clone(environment()) && !environment()->QueryProp(P_NETDEAD_INFO))
    write("\nACHTUNG: Wenn Du hier laenger als ETWA 10 Minuten schlaefst, kommst Du nicht\nan diesen Ort zurueck !\n");
  say(name(WER)+" hat gerade die Verbindung zum "+MUDNAME+" gekappt.\n");
  
  SetProp(P_AWAY, 0);
  
  remove_interactive(ME);
  return 1;
}

static int finger (string str)
{
  string ret;
  mixed xname;

  if (!str||str==""||sizeof(explode(str," ")-({"-n","-p"}))>1)
  {
    write("finger <spielername> oder finger <spielername@mudname>\n"+
      "Bitte nur den reinen Spielernamen verwenden, keine Namensvorsaetze oder Titel.\n");
    return 1;
  }
  xname=explode(str,"@");
  if(sizeof(xname)==2)
  {
    if (ret=INETD->send_udp(xname[1],([
                   REQUEST: "finger",
                   SENDER: getuid(ME),
                   DATA: (explode(xname[0]," ")-({"-n","-p"}))[0]
                   ]), 1))
            write(ret);
        else
      write("Anfrage abgeschickt.\n");
    return 1;
  }
  FINGERMASTER->finger_single(str,1);
  return 1;
}

string lalign(string str, int wid)
{
  return (str+"                                                   "+
      "                                                   ")[0..wid-1];
}

#define MUDS_BAR "\
-------------------------------------------------------------------------------"

private void format(mixed mud, mixed hosts, string output)
{
  output += lalign(hosts[mud][HOST_NAME], 20) + "  " +
        (hosts[mud][HOST_STATUS] ?
           hosts[mud][HOST_STATUS] > 0 ?
             "UP       " + ctime(hosts[mud][HOST_STATUS])[4..15] :
             "DOWN     " + ctime(-hosts[mud][HOST_STATUS])[4..15]
         : "UNKNOWN  Never accessed.") + "\n";
}

static int muds() {
  mapping hosts;
  int i;
  mixed muds, output;

  output = lalign("Mudname", 20) + "  Status   Last access";
  output += "\n" + MUDS_BAR[0..strlen(output)] + "\n";
  muds = sort_array(m_indices(hosts = INETD->query("hosts")),#'>);
  map_array(muds, #'format, hosts, &output);
  More(output);
  return 1;
}

// **** local property methods

static int _set_level(int i)
{
  if (!intp(i)) return -1;
  if (i<1 || i>75) return -1;
  return Set(P_LEVEL, i);
}

static int _set_invis(int a)
{
  if(IS_DOMAINMEMBER(this_player()))
  {
	return Set(P_INVIS, intp(a) ? a : !Query(P_INVIS));
  }
  
  return 0;
}

/* sets the terminal type */
/* note: support vt100 (b/w), ansi (color), dumb (none) */
static string _set_tty(string str) {
  if(str != "dumb" && str != "vt100" && str != "ansi") 
    return Query(P_TTY);
  return Set(P_TTY, str);
}

static int stty(string str)
{
  if (str!="dumb"&&str!="vt100"&&str!="ansi"&&str!="reset")
  {
    write("Syntax: stty dumb|vt100|ansi oder reset\n");
  }
  if(str == "reset") {
    printf("\e[30;47m\e[0mDieser Text sollte lesbar sein!\n");
    return 1;
  }
  write("TTY steht jetzt auf "+SetProp(P_TTY,str)+".\n");
  if (str=="vt100")
  {
    if (QueryProp(P_COLOR_COMMUNICATION)!=0)
     { SetProp(P_COLOR_COMMUNICATION, 0); }
    if (QueryProp(P_COLOR_CHANNELD)!=0)
     { SetProp(P_COLOR_CHANNELD, 0); }
  }
  if(str == "ansi" || str == "vt100") {
      printf("Terminal Test:\n");
      printf("VT100: \e[1mfett\e[0m \e[4munterstrichen\e[0m "+
             "\e[5mblinkend\e[0m \e[7minvers\e[0m\n");
      if(str == "ansi") {
          int fg, bg;
          printf("ANSI Farben und VT100 Attribute:\n");
          for(fg = 30; fg <= 37; fg++) {
              for(bg = 40; bg <= 47; bg++) {
                  printf("\e[%d;%dm\e[1m@\e[0m", fg, bg);
                  printf("\e[%d;%dm\e[4m@\e[0m", fg, bg);
                  printf("\e[%d;%dm\e[5m@\e[0m", fg, bg);
                  printf("\e[%d;%dm\e[7m@\e[0m", fg, bg);
              }
              printf("\n");
          }
          printf("Sollte dieser Text hier nicht richtig lesbar\n"
                 "sein, benutze das Kommando stty reset!\n");
      }
  }
  return 1;
}

static int channelcolor(string str)
{
  this_player()->Set(P_COLOR_CHANNELD, SAVE, F_MODE_AS);
  switch(str) {
    case "schwarz":
    case "black": this_player()->SetProp(P_COLOR_CHANNELD, 1);
                  printf("Channel-Farbe auf schwarz eingestellt.\n");
                  break;
    case "rot":
    case "red": this_player()->SetProp(P_COLOR_CHANNELD, 2);
                  printf("Channel-Farbe auf rot eingestellt.\n");
                  break;
    case "blau":
    case "blue": this_player()->SetProp(P_COLOR_CHANNELD, 5);
                  printf("Channel-Farbe auf blau eingestellt.\n");
                  break;
    case "lila":
    case "purple": this_player()->SetProp(P_COLOR_CHANNELD, 6);
                  printf("Channel-Farbe auf lila eingestellt.\n");
                  break;
    case "weiss":
    case "white": this_player()->SetProp(P_COLOR_CHANNELD, 8);
                  printf("Channel-Farbe auf weiss eingestellt.\n");
                  break;
    case "cyan": this_player()->SetProp(P_COLOR_CHANNELD, 7);
                  printf("Channel-Farbe auf cyan eingestellt.\n");
                  break;
    case "gelb":
    case "yellow": this_player()->SetProp(P_COLOR_CHANNELD, 4); 
                  printf("Channel-Farbe auf gelb eingestellt.\n");
                  break;
    case "gruen": 
    case "green": this_player()->SetProp(P_COLOR_CHANNELD, 3); 
                  printf("Channel-Farbe auf gruen eingestellt.\n");
                  break;
    case "fett":
    case "bold": this_player()->SetProp(P_COLOR_CHANNELD, 9);
                  printf("Channel-Farbe auf fett eingestellt.\n");
                  break;
    case "hellblau":
    case "lightblue": this_player()->SetProp(P_COLOR_CHANNELD, 10);
                  printf("Channel-Farbe auf hellblau eingestellt.\n");
                  break;
    case "braun": 
    case "brown":  this_player()->SetProp(P_COLOR_CHANNELD, 11);
                  printf("Channel-Farbe auf braun eingestellt.\n");
                  break;
    case "grau":
    case "gray":
    case "dunkelgrau":
    case "darkgray": this_player()->SetProp(P_COLOR_CHANNELD, 12);
                  printf("Channel-Farbe auf dunkelgrau eingestellt.\n");
                  break;
    case "hellcyan":
    case "lightcyan": this_player()->SetProp(P_COLOR_CHANNELD, 13);
                  printf("Channel-Farbe auf hellcyan eingestellt.\n");
                  break;
    case "hellgruen":
    case "lightgreen": this_player()->SetProp(P_COLOR_CHANNELD, 14);
                  printf("Channel-Farbe auf hellgruen eingestellt.\n");
                  break;
    case "hellrot":
    case "lightred": this_player()->SetProp(P_COLOR_CHANNELD, 15);
                  printf("Channel-Farbe auf hellrot eingestellt.\n");
                  break;
    case "helllila":
    case "hellila":
    case "lightpurple": this_player()->SetProp(P_COLOR_CHANNELD, 16);
                  printf("Channel-Farbe auf hell-lila eingestellt.\n");
                  break;
    case "standard":
    case "default":
    case "hellgrau":
    case "lightgray":
    case "normal": this_player()->SetProp(P_COLOR_CHANNELD, 0);
                  printf("Channel-Farbe auf normal (hellgrau) eingestellt.\n");
                  break;
    default: printf("Farbe nicht erkannt.\n");
   printf("  schwarz, rot, hellrot, gruen, hellgruen, braun, gelb, blau,\n");
   printf("  hellblau, cyan, hellcyan, gruen, hellgruen, lila, helllila, \n");
   printf("  weiss, normal und bold\n");
  }
  if (this_player()->QueryProp(P_TTY)!="ansi")
  {
   printf("Achtung: Farbe nur aktiv wenn 'stty' auf 'ansi' eingestellt!\n");
  }
  return 1;
}

static int commcolor(string str)
{
  this_player()->Set(P_COLOR_COMMUNICATION, SAVE, F_MODE_AS);
  switch(str) {
    case "schwarz":
    case "black": this_player()->SetProp(P_COLOR_COMMUNICATION, 1);
                  printf("Farbe auf schwarz eingestellt.\n");
                  break;
    case "rot":
    case "red": this_player()->SetProp(P_COLOR_COMMUNICATION, 2);
                  printf("Farbe auf rot eingestellt.\n");
                  break;
    case "blau":
    case "blue": this_player()->SetProp(P_COLOR_COMMUNICATION, 5);
                  printf("Farbe auf blau eingestellt.\n");
                  break;
    case "lila":
    case "purple": this_player()->SetProp(P_COLOR_COMMUNICATION, 6);
                  printf("Farbe auf lila eingestellt.\n");
                  break;
    case "weiss":
    case "white": this_player()->SetProp(P_COLOR_COMMUNICATION, 8);
                  printf("Farbe auf weiss eingestellt.\n");
                  break;
    case "cyan": this_player()->SetProp(P_COLOR_COMMUNICATION, 7);
                  printf("Farbe auf cyan eingestellt.\n");
                  break;
    case "gelb":
    case "yellow": this_player()->SetProp(P_COLOR_COMMUNICATION, 4);
                  printf("Farbe auf gelb eingestellt.\n");
                  break;
    case "gruen":
    case "green": this_player()->SetProp(P_COLOR_COMMUNICATION, 3);
                  printf("Farbe auf gruen eingestellt.\n");
                  break;
    case "fett":
    case "bold": this_player()->SetProp(P_COLOR_COMMUNICATION, 9);
                  printf("Farbe auf fett eingestellt.\n");
                  break;
    case "hellblau":
    case "lightblue": this_player()->SetProp(P_COLOR_COMMUNICATION, 10);
                  printf("Farbe auf hellblau eingestellt.\n");
                  break;
    case "braun":
    case "brown":  this_player()->SetProp(P_COLOR_COMMUNICATION, 11);
                  printf("Farbe auf braun eingestellt.\n");
                  break;
    case "grau":
    case "gray":
    case "dunkelgrau":
    case "darkgray": this_player()->SetProp(P_COLOR_COMMUNICATION, 12);
                  printf("Farbe auf dunkelgrau eingestellt.\n");
                  break;
    case "hellcyan":
    case "lightcyan": this_player()->SetProp(P_COLOR_COMMUNICATION, 13);
                  printf("Farbe auf hellcyan eingestellt.\n");
                  break;
    case "hellgruen":
    case "lightgreen": this_player()->SetProp(P_COLOR_COMMUNICATION, 14);
                  printf("Farbe auf hellgruen eingestellt.\n");
                  break;
    case "hellrot":
    case "lightred": this_player()->SetProp(P_COLOR_COMMUNICATION, 15);
                  printf("Farbe auf hellrot eingestellt.\n");
                  break;
    case "helllila":
    case "hellila":
    case "lightpurple": this_player()->SetProp(P_COLOR_COMMUNICATION, 16);
                  printf("Farbe auf hell-lila eingestellt.\n");
                  break;
    case "standard":
    case "default":
    case "hellgrau":
    case "lightgray":
    case "normal": this_player()->SetProp(P_COLOR_COMMUNICATION, 0);
                  printf("Farbe auf normal (hellgrau) eingestellt.\n");
                  break;
    default: printf("Farbe nicht erkannt.\n");
   printf("  schwarz, rot, hellrot, gruen, hellgruen, braun, gelb, blau,\n");
   printf("  hellblau, cyan, hellcyan, gruen, hellgruen, lila, helllila, \n");
   printf("  weiss, normal und bold\n");

  }
  if (this_player()->QueryProp(P_TTY)!="ansi")
  {
   printf("Achtung: Farbe nur aktiv wenn 'stty' auf 'ansi' eingestellt!\n");
  }
  return 1;
}

static int _farbenauswahl(string str)
{
 string *auswahl;

 if (!str)
 {
   printf("Setzen von Farben fuer folgends momentan Moeglich:\n\n");
   printf("Beschreibung                          Befehl              Parameter\n");
   printf("---------------------------------------------------------------------\n");
   printf("Generelles ein/aus von Grafik         stty                ansi, vt100\n");
   printf("Farben fuer Mitteilungen setzen       farbe <was> <welche_farbe>\n");
   printf(" Bsp: 'farbe tm rot' oder 'farbe kanal gruen'             tm, kanal\n");
   printf("\n");
   printf("Moegliche Farben:\n");
   printf("  schwarz, rot, hellrot, gruen, hellgruen, braun, gelb, blau,\n");
   printf("  hellblau, cyan, hellcyan, gruen, hellgruen, lila, helllila, \n");
   printf("  weiss, normal und bold\n");
   printf("\n"); 
   return 1;
 }

 auswahl=explode(str," ");
 if (sizeof(auswahl)<2)
 {
   printf("Eingabe nicht zulaessig / Parameter fehlt.\n");
   return 1;
 }
 if (sizeof(auswahl)>2)
 {
   printf("Zuviele Parameter eingegeben.\n");
   return 1;
 }

 if ((auswahl[0]=="tm") || (auswahl[0]=="teile"))
 {
    commcolor(auswahl[1]);
 }
 if ((auswahl[0]=="channel") || (auswahl[0]=="kanal"))
 {
    channelcolor(auswahl[1]);
 }
 return 1;
}

static int _set_icq(string str)
{
  this_player()->Set(P_ICQ, SAVE, F_MODE_AS);

  if (!str) 
  {
    printf("Derzeit eingestellte ICQ-Nummer: "+
           this_player()->QueryProp(P_ICQ)+".\n");
    return 1;
  }

  if (str=="loeschen")
  {
   printf("OK, ICQ-Nummer wieder geloescht!\n");
   this_player()->SetProp(P_ICQ, 0);
   return 1;
  }

  if (strlen(str)>10)
  {
   printf("Eingabe zu lang! Maximal 10 Zeichen.\n");
   return 1;
  } 

  this_player()->SetProp(P_ICQ, str);
  printf("Neue ICQ-Nummer gesetzt auf: "+str+".\n");
  return 1;
}

static int _set_homepage(string str)
{
  this_player()->Set(P_HOMEPAGE, SAVE, F_MODE_AS);

 if(QueryProp(P_HOMEPAGE) == "none")
  { SetProp(P_MAILADDR, 0); }

  if (!(str=_unparsed_args()))
  {
    if(!stringp(QueryProp(P_HOMEPAGE)))
    {
        write("Du hast Dir keine Homepage gesetzt!\n");
        return 1;
    }
    write("Deine offizielle Homepage Adresse lautet: \n"+
          QueryProp(P_HOMEPAGE)+"\n");
    return 1;
  }

  if (strlen(str)>57)
  {
   printf("Eingabe zu lang! Maximal 57 Zeichen moeglich.\n");
   return 1;
  }

  if(str == "loeschen")
  {
    write("Ok, Du hast Deine offizielle Homepage geloescht.\n");
    SetProp(P_HOMEPAGE, 0);
  }
  else
  {
    write("Deine offizielle Homepage wurde geaendert.\n");
    SetProp(P_HOMEPAGE, str);
  }
  return 1;

}

static int anzeige(string str)
{
  string s1;

  if ((!str) || (str==""))
  {
    write ("Aktuelle Einstellung der Anzeige:\n");
    switch (QueryProp (P_COLUMN_MODE))
    {
      case 0:
        write ("Objekte werden untereinander angezeigt und");
        break;
      case 1:
        write ("Objekte werden in Spalten angezeigt und");
        break;
      default:
        write ("Ueber sechs Objekte werden in Spalten angezeigt, es wird");
    }
    write ((QueryProp(P_SHORTINV) ? " immer" : " nie") + " gruppiert.\n");

    return 1;
  }

  if (sscanf (str, "spalten%s", s1)==1)
  {
    switch (s1)
    {
      case "":
      case " ein":
        write ("Ok, Objekte werden jetzt in Spalten angezeigt.\n");
        SetProp (P_COLUMN_MODE, 1);
        break;
      case " aus":
        write ("Ok, Objekte werden jetzt untereinander angezeigt.\n");
        SetProp (P_COLUMN_MODE, 0);
        break;
      case " auto":
        write ("Ok, Objekte (mehr als 6) werden jetzt automatisch in "+
          "Spalten angezeigt.\n");
        SetProp (P_COLUMN_MODE, 2);
        break;
      default:
        write ("anzeige spalten ein|aus|auto\n");
    }
  }
  else if (sscanf (str, "gruppieren%s", s1)==1)
  {
    switch (s1)
    {
      case "":
      case " ja":
        write ("Ok, Objekte werden jetzt gruppiert.\n");
        SetProp (P_SHORTINV, 1);
        break;
      case " nein":
        write ("Ok, Objekte werden nicht gruppiert.\n");
        SetProp (P_SHORTINV, 0);
        break;
      default:
        write ("anzeige gruppieren ja|nein\n");
    }
  }
  else
    write("Syntax:\nanzeige gruppieren ja|nein\nanzeige spalten ein|aus|auto\n");

  return 1;
}

// XxXxXxXxXx

int more(string str) 
{
  if(!str) 
  {
    notify_fail("Usage: more <file>\n");
    return 0;
  }
  if (file_size(str) <= 0) {
    notify_fail(str+": No such file\n");
    return 0;
  }
  More(str, 1);
  return 1;
}

static int set_screensize(string str)
{
  int size;

  if (str && (str[0..2] == "abs" || str[0..2]=="rel")) {
    size = QueryProp(P_MORE_FLAGS);
    if (str[0..2] == "abs") {
      size |= E_ABS;
      write("Ok, beim Prompt wird die Zeilenzahl des Textes angegeben.\n");
    }
    else {
      size &= ~E_ABS;
      write("Ok, beim Prompt wird der prozentuale Anteil des Textes "
          "angegeben.\n");
    }
    SetProp(P_MORE_FLAGS, size);
    return 1;
  }
  if (!str || str=="" || !sscanf(str,"%d",size) || size<0 || size>100)
  {
    write(break_string(
        sprintf("Mit dem Befehl 'zeilen <groesse>' kannst Du einstellen, "
            "wieviele Zeilen bei mehrseitigen Texten auf einmal ausgegeben "
            "werden. Die angegebene Groesse muss zwischen 0 und 100 liegen. "
            "Bei Groesse 0 wird einfach alles ausgegeben (ohne Pause). Die "
            "Voreinstellung ist 20 Zeilen.\n"
            "Mit 'zeilen abs[olut]' und 'zeilen rel[ativ]' kannst Du fest"
            "legen, ob im Prompt bei langen Texten die aktuelle Zeilennummer "
            "oder eine prozentuale Angabe ausgegeben wird.\n"
            "Deine aktuelle Einstellung ist %d Zeilen (%s).",
            QueryProp(P_SCREENSIZE),
            QueryProp(P_MORE_FLAGS) & E_ABS ? "absolut" : "relativ"),78,0,1));
    return 1;
  }
  SetProp(P_SCREENSIZE,size);

  printf("Ok, Deine Zeilenzahl steht nun auf %d.\n",size);
  return 1;
}

static int presay(string str)
{
  if( strlen(_unparsed_args()) > 35 )
  {
    write("Das ist leider zu lange.\n");
    return 1;
  }
  if( strlen(_unparsed_args()) + strlen(QueryProp(P_TITLE)) > 65  )
  {
    write("Zusammen mit Deinem Titel ist das leider zu lange.\n");
    return 1;
  }
  if (!str=_unparsed_args())
    write("Dein Presay ist jetzt geloescht.\n");
  else
    printf("Dein Presay lautet jetzt: \"%s\".\n",str=capitalize(str));
  SetProp(P_PRESAY,str);
  write(short());
  return 1;
}

static int sethands(string str)
{
  mixed *hands;

  if (!(str=_unparsed_args()))
  {
    write("sethands <message>\n");
    return 1;
  }
  hands=Query(P_HANDS);
  hands[0]=" "+str;
  Set(P_HANDS,hands);
  write("Ok.\n");
  return 1;
}

static int inform(string str)
{
  switch (str) {
    case "on":
    case "ein":
    case "an":
      if (Query(P_INFORMME))
    write("Das hattest Du schon so eingestellt.\n");
      else
      {
    write("Kuenftig wirst Du informiert, wenn jemand das "+MUDNAME+" "
        "verlaesst/betritt.\n");
    Set(P_INFORMME,1);
      }
      return 1;
    case "aus":
    case "off":
      if (!Query(P_INFORMME))
    write("Das hattest Du schon so eingestellt.\n");
      else
      {
    write("Ok.\n");
    Set(P_INFORMME,0);
      }
      return 1;
    case 0:
      write("Inform-Mode ist "+(Query(P_INFORMME)?"an":"aus")+"geschaltet.\n");
      return 1;
    }
  write("inform an oder inform aus, bitte.\n");
  return 1;
}

void delayed_write(mixed *what)
{
  if (!pointerp(what)||!sizeof(what)||!pointerp(what[0]))
    return;
  tell_object(ME,what[0][0]);
  if (sizeof(what)>1&&sizeof(what[0])>1)
    call_out("delayed_write",what[0][1],what[1..]);
}

void notify_player_change(string who, int rein, int invis)
{
  string *list;
  string bon,boff;  
  if (QueryProp("tty")!="dumb")
  {
    bon = ANSI_BLINK;
    boff = ANSI_NORMAL;
  }
  if (Query(P_INFORMME))
  {
    if (rein)
    {
      if(!IS_QUESTWIZ(ME))
      {
      	tell_object(ME,
      	 	sprintf(who+" ist gerade %sins "+MUDNAME+" gekommen.\n", 
                (invis?bon+"UNSICHTBAR "+boff:"")));
      }
      else
      {
      	tell_object(ME,
      		sprintf(who+" [%s] ist gerade %sins "+MUDNAME+" gekommen.\n",
      		query_ip_name(find_player(lowerstring(who))),
      		(invis?bon+"UNSICHTBAR "+boff:"")));
      }
    }
    else
      tell_object(ME,who+" hat gerade das "+MUDNAME+" verlassen.\n");
  }
  if (pointerp(list=Query(P_WAITFOR))&&sizeof(list))
    if (member(list,who)!=-1)
        tell_object(ME, sprintf("\a%s   I S T   J E T Z T  %s%sD A !!!\n", who,
                   (rein ? "" : "N I C H T   M E H R   "),
                   (invis&&rein?bon+"U N S I C H T B A R  "+boff:"")));
}

static int erwarte(string str)
{
  string *list;
  int i;

  if (str)
  {
    str=capitalize(lower_case(str));
    if (!pointerp(list=Query(P_WAITFOR)))
      list=({});
    if (member(list,str)!=-1)
    {
      list-=({str});
      write(str+" aus der Liste entfernt.\n");
    } else
    {
      list+=({str});
      write(str+" an die Liste angehaengt.\n");
    }
    Set(P_WAITFOR,list);
    }
  list=Query(P_WAITFOR);
  write("Du erwartest jetzt ");
  if (!pointerp(list)||!sizeof(list))
  {
    write("niemanden mehr.\n");
    return 1;
  }
  for (i=sizeof(list)-1;i>=0;i--)
    write(list[i]+(i?", ":".\n"));
  return 1;
}

static int uhrmeldung(string str)
{
  if (!(str=_unparsed_args()))
  {
    str=QueryProp(P_CLOCKMSG);
    if (!str)
    {
      write("Du hast die Standard-Uhrmeldung.\n");
      return 1;
    }
	if( !stringp(str) ) str = sprintf("%O\n",str);
    printf("Deine Uhrmeldung ist: \"%s\"\n",str[0..<2]);
    return 1;
  }
  if (str=="0")
  {
    SetProp(P_CLOCKMSG,0);
    write("Ok, Du hast jetzt wieder die Standard-Meldung.\n");
    return 1;
  }
  if (sizeof(explode(str,"%d"))>2)
  {
    write("Fehler, es darf nur ein %d im String vorkommen.\n");
    return 1;
  }
  str+="\n";
  SetProp(P_CLOCKMSG,str);
  write("Ok.\n");
  return 1;
}

static int muduptime()
{
  write ("Letzter Reboot: "+dtime(last_reboot_time())+",\n");
  write ("Uptime: "+uptime()+".\n");
  return 1;
}

static int raste()
{
  if (QueryProp(P_RESTING))
    write("Aber Du rastest doch schon!\n");
  else if (QueryProp(P_GHOST))
    write("Als Geist kannst Du nicht rasten oder Ruhe finden!\n");
  else if (time() < QueryProp(P_LAST_AWAKE_TIME) + 300)
    write("So oft kannst Du Dich nicht ausrasten!\n");
  else {
    write("Du schliesst die Augen und rastest Dich ein wenig aus. "
        "Tut das gut...\n");
    SetProp(P_RESTING, 1);
    call_out("wache", 60, "auf");
  }
  return 1;
}

static int wache(string str)
{
  if (str!="auf") return 0;
  if (!QueryProp(P_RESTING))
    return write("Aber Du rastest doch gar nicht!\n"), 1;
  while (remove_call_out("wache") != -1) ;
  if (find_call_out("wache2")!=-1)
    return write("Gedulde Dich doch ein wenig!\n"), 1;
  if (QueryProp(P_GHOST)) {
    write("Etwas zu spaet wachst Du wieder auf...\n");
    SetProp(P_RESTING, 0);
    SetProp(P_LAST_AWAKE_TIME, time());
    return 1;
  }
  write("Nach und nach wirst Du wieder munter.\n");
  call_out("wache2", 10);
  return 1;
}

static void wache2()
{
  if (!QueryProp(P_GHOST))
    write("Frisch erholt erhebst Du Dich.\n");
  SetProp(P_RESTING, 0);
  SetProp(P_LAST_AWAKE_TIME, time());
}

static int pluendern(string str)
{
  if( str == "ein" || str == "ja" )
  {
    write("Du pluenderst jetzt alle Leichen aus.\n");
    SetProp(P_LOOTING, 1);
  }
  else if( str == "aus" || str == "nein" )
  {
    write("Du pluenderst jetzt keine Leichen mehr aus.\n");
    SetProp(P_LOOTING, 0);
  }
  else
  {
    write("Du pluenderst zur Zeit "+( QueryProp(P_LOOTING) ? "alle" : "keine" )+
         " Leichen aus.\n");
    write("Umschalten mit 'pluendern <ein|aus>.\n");
  }
  return 1;
}

static string *_query_localcmds()
{
  return ({({"zeilen","set_screensize",0,0}),
           ({"email","set_email",0,0}),
	   ({"ort", "set_ort", 0, 0}),
           ({"punkte","score",0,0}),
           ({"score","score",0,0}),
           ({"info","info",0,0}),
           ({"quit","new_quit",0,0}),
           ({"ende","new_quit",0,0}),
           ({"disconnect","disconnect",0,0}),
           ({"schlaf","disconnect",1,0}),
           ({"speichern","save_character",0,0}),
           ({"save","save_character",0,0}),
           ({"toete","kill",0,0}),
           ({"passw","change_password",1,0}),
           ({"hilfe","help",1,0}),
           ({"selbstloeschung","self_delete",0,0}),
           ({"spielpause","spielpause",0,0}),
           ({"epidee","epidea",0,LEARNER_LVL}),
           ({"idee","idea",0,0}),
           ({"typo","typo",0,0}),
           ({"bug","bug",0,0}),
           ({"detail","detail",0,0}),
           ({"fehler","bug",0,0}),
           ({"vorsicht","toggle_whimpy",0,0}),
           ({"stop","stop",0,0}),
           ({"kwho","kwho",0,0}),
           ({"kwer","kwho",0,0}),
           ({"kkwer","kkwho",0,0}),
           ({"kkwho","kkwho",0,0}),
           ({"who","who",0,0}),
           ({"wer","who",0,0}),
           ({"zeit","uhrzeit",0,0}),
           ({"uhrzeit","uhrzeit",0,0}),
           ({"weg","weg",0,0}),
           ({"finger","finger",0,0}),
           ({"muds","muds",0,0}),
           ({"emote","emote",0,0}),
           ({":","emote",1,0}),
           ({"gemote","emote",0,0}),
           ({";","emote",1,0}),
           ({"remote","remote",0,0}),
           ({"r:","remote",1,0}),
           ({"rgemote","rgemote",0,0}),
           ({"r;","rgemote",1,0}),
           ({"titel","set_title",0,SEER_LVL}),
           ({"review","review",0,SEER_LVL}),
           ({"setmin","setmin",0,SEER_LVL}),
           ({"setmout","setmout",0,SEER_LVL}),
           ({"setmmin","setmmin",0,SEER_LVL}),
           ({"setmmout","setmmout",0,SEER_LVL}),
           ({"setcmsg","setcmsg",0,LEARNER_LVL}),
           ({"setdmsg","setdmsg",0,LEARNER_LVL}),
           ({"sethands","sethands",0,SEER_LVL}),
           ({"presay","presay",0,SEER_LVL}),
           ({"extralook","extralook",0,SEER_LVL}),
           ({"fluchtrichtung","toggle_whimpy_dir",0,SEER_LVL}),
           ({"inform","inform",0,0}),
           ({"erwarte","erwarte",0,0}),
           ({"stty","stty",0,0}),
           ({"farbe","_farbenauswahl",0,0}),
           ({"farben","_farbenauswahl",0,0}),
           ({"icq","_set_icq",0,0}),
           ({"homepage","_set_homepage",0,0}),
           ({"anzeige","anzeige",0,0}),
           ({"uhrmeldung","uhrmeldung",0,0}),
     	   ({"behalte","behalte",0,0}),
           ({"uptime","muduptime",0,0}),
           ({"rast","raste",0,0}),
           ({"raste","raste",0,0}),
           ({"wach","wache",0,0}),
           ({"wache","wache",0,0}),
           ({"steh","wache",0,0}),
           ({"stehe","wache",0,0}),
           ({"pluendern","pluendern",0,0}),
  })+
     sense::_query_localcmds()+
     command::_query_localcmds()+
     viewcmd::_query_localcmds()+
     comm::_query_localcmds();
}

#if 0
void telnet_neg(mixed opt,mixed cmd,mixed args)
{
  if (cmd==34)             
  {          
    switch (opt)  
    {
      case 251: //WILL
      binary_message(({255,250,34,1,1,255,240}));
      break; 
      default: break;
    }
  }
}
#endif

static string _query_auth_info()
{
  mixed auth;

  if (!interactive(ME))
    return Set(P_AUTH_INFO,0);
  if (stringp(auth=Query(P_AUTH_INFO))) return auth;
  if (auth>3) return Set(P_AUTH_INFO,"UNKNOWN");
  "/secure/master"->get_auth_user(ME);
  (void)Set(P_AUTH_INFO,++auth);
  return "NOT YET KNOWN";
}

static string _set_auth_info(mixed s)
{
  if (!previous_object(1)||file_name(previous_object(1))[0..7]!="/secure/")
    return 0;
  Set(P_AUTH_INFO,s);
}

void _set_my_ip(string str)
{
  if (file_name(previous_object())[0..7]!="/secure/") return;
  my_ip=str;
}

string _query_my_ip()
{
  return my_ip;
}

mixed _set_testplayer(mixed arg) {
  mixed res;
  object setob;

  setob=this_player();
  if (!objectp(setob) || !query_once_interactive(setob))
    setob=this_interactive();
  if (!objectp(setob))
    setob=previous_object();
  if (setob && !IS_ARCH(setob)) {
    arg=geteuid(setob);
    if (!arg || arg=="NOBODY")
      arg=getuid(setob);
    arg=capitalize(arg);
  }
  res=Set(P_TESTPLAYER,arg);
  Set(P_TESTPLAYER,PROTECTED,F_MODE_AS);
  return res;
}

static int _check_keep(object ob)
{
  return (ob->QueryProp(P_KEEP_ON_SELL))==geteuid(ME);
}

int behalte(string str)
{
  object *obs, ob;
  string s;

  if (str)
  {
    if (str=="nichts")
    {
      map_objects(filter_objects(all_inventory(ME),"short"),
          "SetProp", P_KEEP_ON_SELL, 0);
      write("Ok, Du behaeltst bei 'verkaufe alles' nichts mehr.\n");
      return 1;
    }
    obs=present_objects(str);
    if (!sizeof(obs))
    {
      _notify_fail("Aber sowas hast Du nicht dabei!\n");
      return 0;
    }
    if (sizeof(filter_array(obs,#'_check_keep)) != sizeof(obs))
    {
      map_objects(obs, "SetProp", P_KEEP_ON_SELL, geteuid(ME));
      write(break_string("Ok, Du wirst "+CountUp(map_objects(obs,"name",WEN))+
          " jetzt bei 'verkaufe alles' behalten.", 78));
    }
    else
    {
      map_objects(obs, "SetProp", P_KEEP_ON_SELL, 0);
      write(break_string("Ok, Du wirst "+CountUp(map_objects(obs,"name",WEN))+
          " beim naechsten 'verkaufe alles' mitverkaufen!", 78));
    }
    return 1;
  }
  obs=filter_array(all_inventory(ME),#'_check_keep);
  if (!sizeof(obs))
    write("Du hast derzeit nichts zum Behalten markiert!\n");
  else
    More("Du behaeltst bei 'verkaufe alles':\n"+make_invlist(ME,obs));
  return 1;
}

