// Aquamarin 

inherit "std/unit";

#include <properties.h>
#include <language.h>

create()
{
  if (!is_clone(this_object()) )  return;

  ::create();

  SetProp(P_SHORT, "Ein Aquamarin");
  SetProp(P_LONG,  
    "Dieser Aquamarin schimmert in meerblauen Farben.");
  SetProp(P_INFO, break_string( 
    "Der Aquamarine hat eine wasserblaue Farbe. Scheinbar hat er eine enge "
    "Beziehung zu Wasser.",78) );
  SetProp(P_NAME, ({"Aquamarin", "Aquamarine"}) );
  SetProp(P_GENDER, MALE);

  AddSingularId( ({"aquamarin", "edelstein"}) );
  AddPluralId( ({"aquamarine", "edelsteine"}) );
  AddId( "EDELSTEIN" );
  SetCoinsPerUnits(200,1);
  SetGramsPerUnits(5,1);

  SetProp(P_MATERIAL, MAT_AQUAMARINE );
  SetProp(P_NOBUY, 1);

}
