// Bernstein 

inherit "std/unit";

#include <properties.h>
#include <language.h>

create()
{
  if (!is_clone(this_object()) )  return;

  ::create();

  SetProp(P_SHORT, "Ein Bernstein");
  SetProp(P_LONG,  
    "In diesem leuchtend gelben Bernstein ist ein winziges Kaeferchen "
    "eingeschlossen.");
  SetProp(P_INFO, break_string(
    "In manchen Sagen heisst es, Bernstein sei eingefrorenes Licht, aber "
    "die Aehnlichkeit zu Baumharz ist kaum von der Hand zu weisen. Trotzdem "
    "besitzt Bernsteine eine sonderbare Beziehung zu Licht.",78));
  SetProp(P_NAME, ({"Bernstein", "Bernsteine"}) );
  SetProp(P_GENDER, MALE);

  AddSingularId( ({"bernstein", "edelstein"}) );
  AddPluralId( ({"bernsteine", "edelsteine"}) );
  AddId( "EDELSTEIN" );
  SetCoinsPerUnits(180,1);
  SetGramsPerUnits(5,1);

  SetProp(P_MATERIAL, MAT_AMBER );
  SetProp(P_NOBUY, 1);

}
