//  Perle

inherit "std/unit";

#include <properties.h>
#include <language.h>

create()
{
  if (!is_clone(this_object()) )  return;

  ::create();

  SetProp(P_SHORT, "Eine Perle");
  SetProp(P_LONG,  
    "Diese Perle ist berauschend schoen. Sie stammt aus dem Inneren einer "
    "Muschel.");
  SetProp(P_INFO, 
    "In Perlen sollen die Geraeusche der Brandung gespeichert sein.");
  SetProp(P_NAME, ({"Perle", "Perlen"}) );
  SetProp(P_GENDER, FEMALE);

  AddSingularId( ({"perle", "edelstein"}) );
  AddPluralId( ({"perlen", "edelsteine"}) );
  AddId( "EDELSTEIN" );
  SetCoinsPerUnits(270,1);
  SetGramsPerUnits(5,1);

  SetProp(P_MATERIAL, MAT_PEARL );
  SetProp(P_NOBUY, 1);

}
