//  Smaragd

inherit "std/unit";

#include <properties.h>
#include <language.h>

create()
{
  if (!is_clone(this_object()) )  return;

  ::create();

  SetProp(P_SHORT, "Ein Smaragd");
  SetProp(P_LONG,  
    "Der Smaragd ist ein giftgruener Edelstein.");
  SetProp(P_INFO, 
    "Smaragde koennen Gifte heilen, aber auch giftige Wirkungen "
    "verstaerken.\n");
  SetProp(P_NAME, ({"Smaragd", "Smaragde"}) );
  SetProp(P_GENDER, MALE);

  AddSingularId( ({"smaragd", "edelstein"}) );
  AddPluralId( ({"smaragde", "edelsteine"}) );
  AddId( "EDELSTEIN" );
  SetCoinsPerUnits(550,1);
  SetGramsPerUnits(5,1);

  SetProp(P_MATERIAL, MAT_EMERALD );
  SetProp(P_NOBUY, 1);

}
