// Setzt die RCS-Eintraege des letzten Tages als Newsartikel in magier.mudlib
// 03.02.99 Rikus@mg.mud.de

#include <daemon.h>

#define NEWSFILE "/p/daemon/save/rcs2news.txt"
#define NEWSFILEOLD "/p/daemon/save/rcs2news.old"

#define DEBUG(str) tell_object(find_player("samtpfote"), sprintf("DEBUG: %O\n",str))

static checkrcs()
{
	string str;
	mixed art;
	// Falls das Skript noch roedelt...
	if (file_time(NEWSFILE)+1800 > time()) return;
	if (!(str=read_file(NEWSFILE,0,10000)) || (str=="")) return;
	art=({"rcs2news","RCS2NEWS",0,0,"RCS-Eintraege bis "+str[0..10],str});
    	if (("/secure/news"->WriteNote(art,1)>=1) ||
	    	(("/secure/news"->RemoveNote("rcs2news",0)>=1) &&
	    	 ("/secure/news"->WriteNote(art,1)>=1)))
		    catch(rename(NEWSFILE,NEWSFILEOLD));
		else log_file("RCS2NEWS",dtime(time())+
		              " : Kann RCS-Eintraege nicht nach rcs2news posten!\n");
}

reset()
{
	// call_out() noetig, da sonst kein weiteres reset() gerufen wird
	// reset() wird nur gerufen bei einem call einer anderen Funktion
	// nach einem Reset
	call_out("checkrcs",1);
}

void create()
{
  seteuid(getuid());
  reset();
}

void clean_up(int refc)
{
  return 0;
}
