/* NPC-Standard Blueprint 
 * Samtpfote@tamedhon
 *
 * einfach ein search'n'replace "rassename" -> "name" machen
 *
 */

#include <class.h> 
#include <properties.h>
#include <combat.h>
#include <moving.h>

#ifdef LOG
#undef LOG
#endif
#define LOG(x, text) write_file("/log/statistik/npcs/"+x, text)


inherit "/std/mnpc";
inherit "/std/player/moneyhandler";


string *_query_racestring()
{
    if(QueryProp(P_GENDER) == MALE)
    {
	return ({"rassename", "rassenames", "rassename", "rassename"});
    }
    else
    {
	return ({"rassenamein", "rassenamein", "rassenamein", "rassenamein"});
    }
}

int Defend(int dam, string *dts, mixed spell, object enemy)
{
    return ::Defend(dam, dts, spell, enemy);
}

void Attack(object enemy)
{
    if(random(100) <= QueryProp(P_SPELLRATE))
    {
	// hier Attacken eintragen
	::Attack(enemy);
    }
    else
    ::Attack(enemy);
}

void create_default_rassename(int level)
{
    int	num;

    ::create_default_npc(level);
    SetProp(P_SPELLRATE, 10+level/2+random(level*2)); 
    if(QueryProp(P_SPELLRATE) >= 100)
    { SetProp(P_SPELLRATE, 80+random(16)); }

    SetProp(P_KILL_NAME, this_object()->name());
    if(level <= 35+random(6))
    { 
	SetProp(P_ATTRIBUTES, 
	    ([A_CON: level+(random(level)/6)-(random(level)/6),
	      A_DEX: level+(random(level)/6)-(random(level)/6),
	      A_INT: level+(random(level)/6)-(random(level)/6),
	      A_STR: level+(random(level)/6)-(random(level)/6)
	    ]));
    }
    else
    {
	SetProp(P_ATTRIBUTES, ([A_CON: 35, A_DEX: 35, A_INT: 35, A_STR: 35]));
    }
    
    SetProp(P_BODY, (level<30?level*2:level)+random(15));
    SetProp(P_HANDS, 
	({" mit stinkenden Haenden",
	  30+(level/3)+random(10),
	  DT_BLUDGEON
	}));
    AddId("\nrassename");
    AddId("rassename");
    
    SetProp(P_GENDER, MALE);
    SetProp(P_NAME, "rassename");
    SetProp(P_RACE, "rassename");
    SetProp(P_SHORT, "Ein unbeschriebener rassename");
    SetProp(P_LONG, "Das ist ein unbeschriebener rassename.\n");
    SetProp(P_AVERAGE_SIZE, 170);
    SetProp(P_SIZE, );
    SetProp(P_AVERAGE_WEIGHT, 70000);
    SetProp(P_WEIGHT, );
    SetProp(P_ATTRIBUTES_OFFSETS, 
	([A_DEX: 0, A_CON: 0, A_INT: 0, A_STR: 0]));
    SetProp(P_MAX_HANDS, 2);
    SetProp(P_AGGRESSIVE, 0);
    SetProp(P_DEFAULT_INFO,
	({"zuckt ahnungslos mit den Schultern.\n",
	  "bohrt sich unwissend in die Nase.\n",
	  "hat davon keinen Schimmer.\n",
	  "interessiert sich nicht dafuer.\n",
	  "gruebelt darueber nach, aber hat trotzdem keine Ahnung.\n"
	}));
    SetProp(P_LOG_INFO, 1);
    SetProp(P_RESISTANCE, 0);
    SetProp(P_VULNERABILITY, 0);
    SetProp(P_TEMPERATURE_RANGE, ([T_RANGE_MIN: 10, T_RANGE_MAX: 30]));  
    SetProp(P_NOMAGIC, 0);
    SetProp(P_SPELLRATE, 0);
    SetProp(P_WIMPY, 0);
    SetProp(P_DIE_MSG, " faellt blutueberstroemt und sehr tot zu Boden.\n");

    SetProp(P_MSGIN, "geht herein");
    SetProp(P_MSGOUT, "geht weiter#");
    SetProp(P_MMSGIN, "erscheint mit einen leisen *POFF*");
    SetProp(P_MMSGOUT, "verschwindet mit Rauch und Gestank");
    
    SetProp(P_MAX_FOOD, 100);
    SetProp(P_MAX_ALCOHOL, 100);
    SetProp(P_MAX_DRINK, 100);
    
    SetProp(P_ALIGN, 0);

    if(!is_class_member(CL_HUMANOID)) { AddClass(CL_HUMANOID); }
    if(!is_class_member(CL_rassename)) { AddClass(CL_rassename); }
}

void create_default_npc(int level)
{ create_default_rassename(level); }


int create()
{
    if(!is_clone(this_object())) return 0;
    ::create();
}
