// SilberLand MUDlib
//
// std/player/soulhelp.c -- Verb-Hilfe
//
// $Date: 1998/01/21 14:55:47 $
/* $Revision: 3.2 $
 * $Log: soulhelp.c,v $
 * Revision 3.2  1998/01/21 14:55:47  Feyaria
 * Neue Verben eingetragen
 *
 * Revision 3.1  1997/03/31 04:43:35  Woody
 * neue Verben eingetragen
 *
 * Revision 3.0  1997/03/13 01:49:13  Woody
 * prepared for revision control
 *
 * SL-Version: one new verb
 * -Crea-
 *
 * new AnderLand version by -Creative- 1995
 * adapted 2 remote-cmds, and 6 own cmds.
 * special mags may use another important cmd! :)
 */

#include <wizlevels.h>

string *wizcmds, *plrcmds, *ghostcmds;

create()  {
  plrcmds=({
        "zuck", "schmieg", "antworte", "applaudiere",
        "betaste", "cls", "drehe (daeumchen)", "danke",
        "druecke", "erroete", "flippe", "frage",
      	"furze", "gaehne", "gluckse", "grinse",
        "guck", "haetschel", "hickse", "huepfe",
        "huste", "keuche", "kichere", "klatsche",
        "knabbere", "knickse", "knirsche", "knurre",
        "knutsche", "kotze", "kuesse", "lache",
        "laechle", "liebe", "nicke", "niese",
        "gib", "pfeife", "ruelpse", "runzle",
        "schmolle", "schmunzle", "schnippe", "schnarche",
        "schnurre", "schreie", "schuettle", "seufze",
        "singe", "sniefe/schniefe", "spucke", "starre",
        "staune", "stiere", "stoehne", "stosse",
        "streichle", "tanze", "tritt", "troeste",
        "umarme", "verneige", "wackle", "waelze",
        "weine", "winke", "zwinkere", "verben",
        "aechze", "erbleiche", "fluche", "verfluche",
        "kitzle", "nein", "deute", "zeige",
        "denke [text]", "knuddle", "taetschel", "wuschel",
        "baeh / strecke ... [die] zunge raus", "kratz",
        "grummel", "jubel / juble ... [zu]", "wuerg",
        "gratuliere / beglueckwuensche", "raeusper",
        "argl", "rotfl", "grunz", "kuschel", "atme ... auf",
        "freue", "sniff", "grueble", "bohre ... [in der nase]",
        "putze [nase]", "bibbere", "quietsche/quieke", "schluchze",
        "schnaufe", "schnaube", "philosophiere", "sabbere",
        "stimme [...] zu", "krieche", "mustere", "schaeme",
        "schnalze ... [zunge]", "stampfe ... [auf]",
        "reibe ... [haende]", "fauche ... [an]",
        "beneide", "wische ... [schweiss]", "lag", "idle",
        "rgrinse", "rgratuliere / rgratse", "traeume",
        "baue [luftschloss]", "betrachte", "blicke [ins leere]",
        "prust", "begruesse / hallo / hi", "entschuldige",
        "erschrecke", "aergere", "lobe", "kuck", "schweige",
        "zupfe", "warte", "wundere",
        "bedauer", "beruhige", "bettel", "glubsche", "groehle",
        "haensel", "hechel", "hoere .. [zu]", "huestel", "jaule",
        "kneife", "knie nieder", "knuffe", "krabbel",
        "kraule", "kreische", "mecker", "nerve", "quengel",
        "rolle", "ruettel", "schiele", "schmachte", "schmeichel",
        "schmuse", "schneuze", "springe", "strahle", "stubse",
        "taumel", "torkel", "klopfe .. [auf schulter]",
        "jammere", "haue", "friere", "murmel", "traellere",
        "gacker", "schlucke", "piepse", "fuchtel", "stolziere",
        "ruempfe", "roechel", "japse", "brumme", "bitte",
        "fuerchte", "spanne ..[Muskeln an]", "ermuntere", 
        "verblueffe", "beschimpfe","wuensche", "stolpere",
        "flausche", "beisse", "geniesse", "summe", "wimmer", "schubse",
        "rdanke", "rwuschel", "rnicke", "rlaechel", "rtroeste",
	});
	wizcmds=({
		"splash", "flame",
	});
	ghostcmds=({
		"rassel/rassle", "heule",
	});
}

Help()  {
  string out;
  out = break_string(
      "Standardverben:\n"+implode(SortIt(plrcmds), ", ")+".", 78, 0, 1);
  if (IS_WIZARD(this_player()))
    out += "\n"+break_string(
        "Magierverben:\n"+implode(SortIt(wizcmds),", ")+".", 78, 0, 1);
  if (this_player()->ghost())
    out += "\n"+break_string(
        "Geisterverben:\n"+implode(SortIt(ghostcmds), ", ")+".", 78, 0, 1);
  if (IS_ARCH(this_player()))
    out+="\n -"+capitalize(getuid(this_player()))+"-'s Verben:   schwapp :)";
  return out+"\n"+break_string(
      "Einige Befehle reagieren auch auf leicht unterschiedliche "
      "Schreibweise. Diese Befehlsliste ist dynamisch und passt sich "
      "Deinem Status an.", 78);
}

static SortIt(arr)  {
  int i;
  mixed *sort_arr;
  string *ix;
  sort_arr=({ ({}), ({}) });
  ix=arr;
  for (i=sizeof(ix)-1; i>=0; i--)  {
    string tmp1,tmp2;
    sort_arr[0]+=({ ix[i][2]+ix[i][1]*256+ix[i][0]*65536 });
    sort_arr[1]+=({ ix[i] });
  }
  sort_arr = order_alist(sort_arr);
  sort_arr = sort_arr[1];
  return sort_arr;
}

